/*
 * catalog/awt/PreloadWaitFrame.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package catalog.awt;

import ssonet.Preload;
import ssonet.PreloadListener;

import javax.swing.*;
import java.awt.*;

public class PreloadWaitFrame extends JWindow implements PreloadListener  {
    private boolean readyToTakeOff = false;
    private JLabel label;

    public PreloadWaitFrame () {
	Preload preload = new Preload(this);
	label = new JLabel("Initialisiere Provider...", SwingConstants.CENTER);
	getContentPane().setLayout(new BorderLayout());
	getContentPane().add(label, BorderLayout.CENTER);
	setSize (200,80);
	Dimension screenDimension = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension ownDimension = getSize();
	int x = 0;
	int y = 0;
	x = (screenDimension.width - ownDimension.width) / 2;
	y = (screenDimension.height - ownDimension.height) / 2;
	setLocation(x, y);
	show();
	while (!readyToTakeOff) {
	    try {
		Thread.sleep(200);
	    } catch (InterruptedException ie) {}
	}
	label.setText ("rume auf...");
	System.gc();
	dispose ();
    }

    public void providerInstalled() {
        if(label != null){
	    label.setText("Initialisiere Zufallsgenerator...");
	}
    }

    public void preloadInstalled(int installState) {
	readyToTakeOff = true;
    }
}
