/*
 * gateway/GatewayWindow.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
/* EXPERIMENTAL SOURCE CODE */
package gateway;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.ListModel;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.WindowConstants;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.event.*;
import java.util.Hashtable;
import java.io.*;

public class GatewayWindow implements ActionListener, ListSelectionListener {
    private JFrame frame = null;
    private JPanel JFrameContentPane = null;
    private JPanel GWDialogContentPane = null;
    private JButton buttonDlgCancel = null;
    private JButton buttonOK = null;
    private JButton buttonCancel = null;
    private JButton buttonDlgOK = null;
    private JButton delButton = null;
    private JButton newButton = null;
    private JButton propButton = null;
    private JList gatewayList = null;
    private JList mechHinList = null;
    private JList mechBackList = null;
    private JDialog GWDialog = null;
    private JTextField dlgTextIP = null;
    private JTextField dlgTextName = null;
    private JTextField dlgTextPort = null;
    private JComboBox selectHinMech = null;
    private JComboBox selectBackMech = null;
    private JLabel labelGW = null;
    private JLabel dlgLabelIP = null;
    private JLabel labelHinMech = null;
    private JLabel labelBackMech = null;
    private JLabel dlgLabelName = null;
    private JLabel dlgLabelPort = null;
    private JLabel labelDlgHinMech = null;
    private JLabel labelDlgBackMech = null;
    private Hashtable configuration = null;
    public static String GW_NAMES = "GW_NAMES";
    public static final int GW_PORT = 0;
    public static final int GW_IP = 1;
    public static final int GW_HIN_MECH = 2;
    public static final int GW_BACK_MECH = 3;

    private String[] detailConf = new String[4];
    private String[] mechanismsHin = {"Blowfish","CAST5","DES","DES3","IDEA","LOKI91","RC2","RC4","SAFER","SPEED","Square", "ElGamal", "RSA", "DSA"};
    private String[] mechanismsBack = {"Blowfish","CAST5","DES","DES3","IDEA","LOKI91","RC2","RC4","SAFER","SPEED","Square", "ElGamal", "RSA", "DSA"};
    private boolean propBttn = false;

    /**
    * Constructor
    */
    public GatewayWindow() {
	super();
	initialize();
    }
    public void valueChanged(ListSelectionEvent event) {
	if(((JList)event.getSource()).getSelectedIndex() != -1) {
	    if(event.getSource() == getGatewayList()) {
		getDelButton().setEnabled(true);
		getPropButton().setEnabled(true);
	    }
            else {
		getDelButton().setEnabled(false);
		getPropButton().setEnabled(false);
	    }
	}
    }
    /**
    * Method to handle events for the ActionListener interface.
    * @param e java.awt.event.ActionEvent
    */
    public void actionPerformed(ActionEvent e) {
	if ((e.getSource() == getNewButton()) ) {
	    getDlgTextName().setText("");
	    getDlgTextIP().setText("");
	    getDlgTextPort().setText("");
	    getSelHinMech().setSelectedIndex(0);
	    getGWDialog().show();
	    getGWDialog().toFront();
	} else if(e.getSource() == getButtonDlgOK()) {
	    if(propBttn)
		actionPerformed(new ActionEvent(getDelButton(),0, null));
	    propBttn=false;
	    String errStr = testInputParams();
	    if(errStr != null)
		JOptionPane.showMessageDialog(null,"Fehlerhafte Eingabe ("+errStr+").", "Fehler", JOptionPane.ERROR_MESSAGE);
	    else {
		String[] str = null;
		int length = 0;
		if (getGatewayNames() != null) length = getGatewayNames().length;
		str = new String[length + 1];
		for(int i=0; i<length; i++)
		    str[i] = getGatewayNames()[i];
		str[length] = getDlgTextName().getText();
		//Test ob Gateway schon in der Liste vorhanden
		boolean found = false;
		for(int i=0; i<str.length-1; i++) {
		    if(str[i].equals(getDlgTextName().getText())) {
			JOptionPane.showMessageDialog(null,"Gateway schon vorhanden.", "Fehler", JOptionPane.ERROR_MESSAGE);
			found=true;
		    }
		}
		if(!found) {
		    getGatewayList().setListData(str);
		    configuration.put(GW_NAMES, str);
		    String[] dc = new String[4];
		    dc[0] = getDlgTextPort().getText();
		    dc[1] = getDlgTextIP().getText();
		    dc[2] = (String)getSelHinMech().getModel().getSelectedItem();
		    dc[3] = (String)getSelBackMech().getModel().getSelectedItem();
		    configuration.put(getDlgTextName().getText(), dc);
		    setMechHinBackElements();
		    getPropButton().setEnabled(false);
		    getDelButton().setEnabled(false);
		    getGWDialog().dispose();
		}
	    }
	} else if((e.getSource() == getButtonDlgCancel()) ) {
	    propBttn=false;
	    getGWDialog().dispose();
	} else if((e.getSource() == getPropButton()) ) {
	    propBttn=true;
	    String str = (String)getGatewayList().getSelectedValue();
	    detailConf = (String[])configuration.get(str);
	    getDlgTextName().setText(str);
	    getDlgTextPort().setText(detailConf[0]);
	    getDlgTextIP().setText(detailConf[1]);
	    getSelHinMech().setSelectedItem(detailConf[2]);
	    getSelBackMech().setSelectedItem(detailConf[3]);
	    getGWDialog().setVisible(true);
	    getGWDialog().toFront();
	} else if((e.getSource() == getDelButton()) ) {
	    String str = (String)getGatewayList().getSelectedValue();
	    Answer answ = new Answer();
	    boolean ans = true;
	    if(!propBttn) ans = answ.getAnswer();
	    if(ans) {
		configuration.remove(str); //selektierter Wert wird gelscht
		String[] mechList = (String[])configuration.get(GW_NAMES);
		String[] newList = new String[mechList.length-1];
		int index=0;
		for(int i=0; i<newList.length; i++) {
		    while(mechList[index++].equals(str));
		    newList[i]=mechList[index-1];
		}
		configuration.put(GW_NAMES, newList);
		getGatewayList().setListData(newList);
		setMechHinBackElements();
		getPropButton().setEnabled(false);
		getDelButton().setEnabled(false);
	    }
	} else if((e.getSource() == getButtonOK()) ) {
	    if(!writeGatewayConfiguration(configuration))
		System.out.println("Error while writing configuration.");
	    frame.dispose();
	    //      System.exit(1);
	} else if((e.getSource() == getButtonCancel()))  {
	    frame.dispose();
	    //      System.exit(1);
	}
    }
    /**
    * Return the JButton property value.
    * @return JButton
    */
    private JButton getButtonDlgCancel() {
	if (buttonDlgCancel == null) {
	    try {
		buttonDlgCancel = new JButton();
		buttonDlgCancel.setName("buttonDlgCancel");
		buttonDlgCancel.setText("Abbrechen");
		buttonDlgCancel.setBounds(146, 206, 100, 25);
		buttonDlgCancel.addActionListener(this);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return buttonDlgCancel;
    }
    /**
    * Return the JButton property value.
    * @return JButton
    */
    private JButton getButtonDlgOK() {
	if (buttonDlgOK == null) {
	    try {
		buttonDlgOK = new JButton();
		buttonDlgOK.setName("buttonDlgOK");
		buttonDlgOK.setText("OK");
		buttonDlgOK.setBounds(18, 206, 100, 25);
		buttonDlgOK.addActionListener(this);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return buttonDlgOK;
    }
    /**
    * Return the JButton2 property value.
    * @return JButton
    */
    private JButton getDelButton() {
	if (delButton == null) {
	    try {
		delButton = new JButton();
		delButton.setName("delButton");
		delButton.setText("Entfernen");
		delButton.setBounds(153, 223, 117, 25);
		delButton.addActionListener(this);
		delButton.setEnabled(false);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return delButton;
    }
    /**
    * Return the frame property value.
    * @return JFrame
    */
    private JFrame getFrame() {
	if (frame == null) {
	    try {
		frame = new JFrame();
		frame.setName("frame");
		//frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.addWindowListener(new WindowAdapter() {
		    public void windowClosing(WindowEvent e) {
			//                  System.exit(1);
		    }});
		    frame.setBounds(23, 18, 424, 316);
		    frame.setTitle("Gateways");
		    frame.setResizable(false);
		    getFrame().setContentPane(getJFrameContentPane());
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return frame;
    }
    /**
    * Return the JList property value.
    * @return JList
    */

    private JList getGatewayList() {
	if (gatewayList == null) {
	    try {
		gatewayList = new JList();
		gatewayList.setName("gatewayList");
		gatewayList.setBounds(18, 42, 234, 165); //384
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return gatewayList;
    }

    private JList getMechHinList() {
	if (mechHinList == null) {
	    try {
		mechHinList = new JList();
		mechHinList.setSelectionBackground(mechHinList.getBackground());
		mechHinList.setName("mechHinList");
		mechHinList.setBounds(252, 42, 80, 165);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return mechHinList;
    }
    private JList getMechBackList() {
	if (mechBackList == null) {
	    try {
		mechBackList = new JList();
		mechBackList.setSelectionBackground(mechBackList.getBackground());
		mechBackList.setName("mechBackList");
		mechBackList.setBounds(332, 42, 70, 165);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return mechBackList;
    }

    /**
    * Return the JDialog property value.
    * @return JDialog
    */
    private JDialog getGWDialog() {
	if (GWDialog == null) {
	    try {
		GWDialog = new JDialog(frame, true);
		GWDialog.setName("internalFrame");
		GWDialog.setBounds(39, 269, 285, 264);
		GWDialog.setTitle("Neues Gateway");
		GWDialog.setResizable(false);
		getGWDialog().setContentPane(getGWDialogContentPane());
		GWDialog.setVisible(false);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return GWDialog;
    }
    /**
    * Return the JFrameContentPane property value.
    * @return JPanel
    */
    private JPanel getJFrameContentPane() {
	if (JFrameContentPane == null) {
	    try {
		JFrameContentPane = new JPanel();
		JFrameContentPane.setName("JFrameContentPane");
		JFrameContentPane.setLayout(null);
		getJFrameContentPane().add(getButtonOK(), getButtonOK().getName());
		getJFrameContentPane().add(getButtonCancel(), getButtonCancel().getName());
		getJFrameContentPane().add(getGatewayList(), getGatewayList().getName());
		getJFrameContentPane().add(getMechHinList(), getMechHinList().getName());
		getJFrameContentPane().add(getMechBackList(), getMechBackList().getName());
		getJFrameContentPane().add(getLabelGW(), getLabelGW().getName());
		getJFrameContentPane().add(getNewButton(), getNewButton().getName());
		getJFrameContentPane().add(getDelButton(), getDelButton().getName());
		getJFrameContentPane().add(getPropButton(), getPropButton().getName());
		getJFrameContentPane().add(getLabelBackMech(), getLabelBackMech().getName());
		getJFrameContentPane().add(getLabelHinMech(), getLabelHinMech().getName());
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return JFrameContentPane;
    }
    /**
    * Return the JInternalFrameContentPane property value.
    * @return JPanel
    */
    private JPanel getGWDialogContentPane() {
	if (GWDialogContentPane == null) {
	    try {
		GWDialogContentPane = new JPanel();
		GWDialogContentPane.setName("DialogContentPane");
		GWDialogContentPane.setLayout(null);
		getGWDialogContentPane().add(getDlgLabelName(), getDlgLabelName().getName());
		getGWDialogContentPane().add(getDlgLabelIP(), getDlgLabelIP().getName());
		getGWDialogContentPane().add(getDlgLabelPort(), getDlgLabelPort().getName());
		getGWDialogContentPane().add(getDlgTextName(), getDlgTextName().getName());
		getGWDialogContentPane().add(getDlgTextIP(), getDlgTextIP().getName());
		getGWDialogContentPane().add(getDlgTextPort(), getDlgTextPort().getName());
		getGWDialogContentPane().add(getButtonDlgOK(), getButtonDlgOK().getName());
		getGWDialogContentPane().add(getButtonDlgCancel(), getButtonDlgCancel().getName());
		getGWDialogContentPane().add(getLabelDlgHinMech(), getLabelDlgHinMech().getName());
		getGWDialogContentPane().add(getLabelDlgBackMech(), getLabelDlgBackMech().getName());
		getGWDialogContentPane().add(getSelHinMech(), getSelHinMech().getName());
		getGWDialogContentPane().add(getSelBackMech(), getSelBackMech().getName());
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return GWDialogContentPane;
    }
    /**
    * Return the JTextField property value.
    * @return JTextField
    */
    private JTextField getDlgTextIP() {
	if (dlgTextIP == null) {
	    try {
		dlgTextIP = new JTextField();
		dlgTextIP.setName("dlgTextIP");
		dlgTextIP.setBounds(84, 58, 176, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return dlgTextIP;
    }
    /**
    * Return the JTextField property value.
    * @return JTextField
    */
    private JTextField getDlgTextName() {
	if (dlgTextName == null) {
	    try {
		dlgTextName = new JTextField();
		dlgTextName.setName("dlgTextName");
		dlgTextName.setBounds(84, 22, 176, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return dlgTextName;
    }
    /**
    * Return the JTextField property value.
    * @return JTextField
    */
    private JTextField getDlgTextPort() {
	if (dlgTextPort == null) {
	    try {
		dlgTextPort = new JTextField();
		dlgTextPort.setName("dlgTextPort");
		dlgTextPort.setBounds(84, 94, 176, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return dlgTextPort;
    }
    /**
    * Return the JButton property value.
    * @return JButton
    */
    private JButton getNewButton() {
	if (newButton == null) {
	    try {
		newButton = new JButton();
		newButton.setName("newButton");
		newButton.setText("Neu");
		newButton.setBounds(18, 223, 117, 25);
		newButton.addActionListener(this);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return newButton;
    }
    /**
    * Return the JButton property value.
    * @return JButton
    */
    private JButton getPropButton() {
	if (propButton == null) {
	    try {
		propButton = new JButton();
		propButton.setName("PropButton");
		propButton.setText("Eigenschaften");
		propButton.setBounds(288, 223, 117, 25);
		propButton.addActionListener(this);
		propButton.setEnabled(false);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return propButton;
    }

    private JButton getButtonOK() {
	if (buttonOK == null) {
	    try {
		buttonOK = new JButton();
		buttonOK.setName("OK");
		buttonOK.setText("OK");
		buttonOK.setBounds(104, 259, 100, 25);
		buttonOK.addActionListener(this);
	    } catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	    }
	}
	return buttonOK;
    }

    private JButton getButtonCancel() {
	if (buttonCancel == null) {
	    try {
		buttonCancel = new JButton();
		buttonCancel.setName("CANCEL");
		buttonCancel.setText("Abbrechen");
		buttonCancel.setBounds(237, 259, 100, 25);
		buttonCancel.addActionListener(this);
	    } catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	    }
	}
	return buttonCancel;
    }
    /**
    * Return the JComboBox property value.
    * @return JComboBox
    */
    private JComboBox getSelHinMech() {
	if (selectHinMech == null) {
	    try {
		selectHinMech = new JComboBox();
		selectHinMech.setName("selectHinMech");
		selectHinMech.setBounds(146, 131, 114, 27);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return selectHinMech;
    }

    /**
    * Return the JComboBox property value.
    * @return JComboBox
    */
    private JComboBox getSelBackMech() {
	if (selectBackMech == null) {
	    try {
		selectBackMech = new JComboBox();
		selectBackMech.setName("selectBackMech");
		selectBackMech.setBounds(146, 166, 114, 27);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return selectBackMech;
    }
    /**
    * Return the JLabel property value.
    * @return JLabel
    */
    private JLabel getLabelDlgBackMech() {
	if (labelDlgBackMech == null) {
	    try {
		labelDlgBackMech = new JLabel();
		labelDlgBackMech.setName("labelDlgBackMech");
		labelDlgBackMech.setText("Eigener Mech.:");
		labelDlgBackMech.setBounds(18, 166, 116, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return labelDlgBackMech;
    }

    /**
    * Return the JTextField property value.
    * @return JTextField
    */
    private JLabel getLabelDlgHinMech() {
	if (labelDlgHinMech == null) {
	    try {
		labelDlgHinMech = new JLabel();
		labelDlgHinMech.setName("labelDlgHinMech");
		labelDlgHinMech.setText("Partnermech.:");
		labelDlgHinMech.setBounds(18, 131, 116, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return labelDlgHinMech;
    }

    /**
    * Return the JTextField property value.
    * @return JTextField
    */
    private JLabel getDlgLabelIP() {
	if (dlgLabelIP == null) {
	    try {
		dlgLabelIP = new JLabel();
		dlgLabelIP.setName("dlgLabelIP");
		dlgLabelIP.setText("IP-Adr.:");
		dlgLabelIP.setBounds(18, 58, 46, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return dlgLabelIP;
    }

    /**
    * Return the JTextField property value.
    * @return JTextField
    */
    private JLabel getLabelGW() {
	if (labelGW == null) {
	    try {
		labelGW = new JLabel();
		labelGW.setName("labelGW");
		labelGW.setText("verfgbare Gateways:");
		labelGW.setBounds(18, 15, 150, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return labelGW;
    }

    /**
    * Return the JLabel property value.
    * @return JLabel
    */
    private JLabel getLabelBackMech() {
	if (labelBackMech == null) {
	    try {
		labelBackMech = new JLabel();
		labelBackMech.setName("labelBackMech");
		labelBackMech.setText("Eigener Mech.");
		labelBackMech.setBounds(332, 15, 100, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return labelBackMech;
    }


    /**
    * Return the JLabel property value.
    * @return JLabel
    */
    private JLabel getLabelHinMech() {
	if (labelHinMech == null) {
	    try {
		labelHinMech = new JLabel();
		labelHinMech.setName("labelHinMech");
		labelHinMech.setText("Partnermech.");
		labelHinMech.setBounds(252, 15, 100, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return labelHinMech;
    }

    /**
    * Return the JTextField property value.
    * @return JTextField
    */
    private JLabel getDlgLabelName() {
	if (dlgLabelName == null) {
	    try {
		dlgLabelName = new JLabel();
		dlgLabelName.setName("dlgLabelName");
		dlgLabelName.setText("Name:");
		dlgLabelName.setBounds(18, 22, 48, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return dlgLabelName;
    }
    /**
    * Return the JTextField property value.
    * @return JTextField
    */
    private JLabel getDlgLabelPort() {
	if (dlgLabelPort == null) {
	    try {
		dlgLabelPort = new JLabel();
		dlgLabelPort.setName("dlgLabelPort");
		dlgLabelPort.setText("Port:");
		dlgLabelPort.setBounds(18, 94, 37, 19);
	    } catch (java.lang.Throwable Exc) {
		handleException(Exc);
	    }
	}
	return dlgLabelPort;
    }
    private String[] getGatewayNames() {
	if(configuration!=null) return (String[])configuration.get(GW_NAMES);
	else return new String[0];
    }
    /**
    * Called whenever the part throws an exception.
    * @param exception java.lang.Throwable
    */
    private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
    }

    /**
    * Initialize the class.
    */
    private void initialize() {
	configuration = readGatewayConfiguration();
        if (configuration!=null) {
	    if (configuration.get(GW_NAMES)==null)
		configuration=null;
        }
    }

    public void showGatewayFrame() {
	getGatewayList().addListSelectionListener(this);
	getFrame().show();
	if(configuration != null) {
	    getGatewayList().setListData(getGatewayNames());
	    setMechHinBackElements();
	}
	else configuration = new Hashtable();
	for(int i=0; i<mechanismsHin.length; i++)
	    getSelHinMech().addItem(mechanismsHin[i]);
	for(int i=0; i<mechanismsBack.length; i++)
	    getSelBackMech().addItem(mechanismsBack[i]);
    }
    /**
    * main entrypoint - starts the part when it is run as an application
    * @param args java.lang.String[]
    */
    public static void main(java.lang.String[] args) {
	try {
	    GatewayWindow aGateway;
	    aGateway = new GatewayWindow();
	    aGateway.showGatewayFrame();
	} catch (Throwable exception) {
	    System.err.println("Exception occurred in main() of java.lang.Object");
	    exception.printStackTrace(System.out);
	}
    }
    public static boolean writeGatewayConfiguration(Hashtable configuration) {
	try {
	    ObjectOutputStream objectOutputStream =
		new ObjectOutputStream(new FileOutputStream(new File(System.getProperty("ssonet_cfg"),"Gateway.dat")));
	    objectOutputStream.writeObject(configuration);
	    objectOutputStream.flush();
	    objectOutputStream.close();
	    return true;
	}
	catch(Exception e) {
	    return false;
	}
    }

    /**Zum Einlesen der Hashtabelle vom File "Gateway.dat"
    * enthlt die komplette Konfiguration der Gateways.
    * @return Hashtable
    */
    public static Hashtable readGatewayConfiguration() {
	try {
	    return (Hashtable)(new ObjectInputStream(new FileInputStream
		(new File(System.getProperty("ssonet_cfg"),
		"Gateway.dat")))).readObject();
	}
	catch(Exception e) {
	    return null;
	}
    }
    private void setMechHinBackElements() {
	String[] names = getGatewayNames();
	if (names!=null) {
	    String[] hinMechNames = new String[names.length];
	    String[] backMechNames = new String[names.length];
	    for(int i=0; i<names.length; i++) {
		hinMechNames[i] = ((String[])configuration.get(names[i]))[GW_HIN_MECH];
		backMechNames[i] = ((String[])configuration.get(names[i]))[GW_BACK_MECH];
	    }
	    getMechHinList().setListData(hinMechNames);
	    getMechBackList().setListData(backMechNames);
	} else {
	    System.out.println("Abbruch - keine Gatewaynamen gefunden");
	    System.exit(1);
	}
    }


    private String testInputParams() {
	if(getDlgTextName().getText().equals("")) return ("Gatewayname");
	if(getDlgTextIP().getText().equals("")) return ("IP-Adr.");
	if(getDlgTextPort().getText().equals("")) return ("Port-Adr.");
	return null;
    }

    /**Diese Funktion gibt alle die Gateways als Namen zurck,
    * die den Mechanismus mech untersttzen.
    * @param mech
    * @return mechNames
    */
    public String[] getGWsupportMech(String mech) {
	int count = 0;
	String[] names = getGatewayNames();
	for(int i=0; i<names.length; i++)
	    if((((String[])configuration.get(names[i]))[GW_HIN_MECH]).equals(mech)) count++;
	String[] mechNames = new String[count+1];
	mechNames[0] = "Cryptix";
	count = 1;
	for(int i=0; i<names.length; i++)
	    if((((String[])configuration.get(names[i]))[GW_HIN_MECH]).equals(mech))
	    mechNames[count++]=names[i];
	return mechNames;
    }

    class Answer {
	int result = 0;
	public Answer() {
	}
	boolean getAnswer() {
	    JOptionPane pane = new JOptionPane();
	    //pane.setLocation(frame.getLocation().getX()+20, frame.getLocation().getY()+20);
	    result = pane.showConfirmDialog(null,"Wollen Sie das Gateway wirklich lschen?", "Warnung", JOptionPane.YES_NO_OPTION);
	    if(result == JOptionPane.YES_OPTION) return true;
	    else return false;
	}
    }
}
