/*
 * smi/awt/JSpinner.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.awt;


import javax.swing.JPanel;
import smi.awt.SpinnerButton;
import smi.awt.JSpinnerUI;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class JSpinner extends JPanel implements ActionListener {
    private Spinner spinner;
    private SpinnerButton bttns;
    private int min, max, step;

    public void actionPerformed(ActionEvent e) {
	if(e.getActionCommand().equals("UP")) {
	    int itmp=spinner.getValue()+step;
	    if(itmp>max)
		itmp=max;
	    spinner.setValue(itmp);
	} else {
	    int itmp=spinner.getValue()-step;
	    if(itmp<min)
		itmp=min;
	    spinner.setValue(itmp);
	}
    }

    public JSpinner(int aktValue, int min, int max, int step) {
	this.min=min;
	this.max=max;
	this.step=step;
	spinner=new Spinner(aktValue);
	spinner.setMaximum(max);
	spinner.setDoubleBuffered(true);
	spinner.setBorderPainted(true);
	spinner.setUI(new JSpinnerUI());
	bttns=new SpinnerButton();

	bttns.addActionListener(this);
	setLayout(new GridLayout(1,2,0,0));
	add(spinner);
	add(bttns);
    }

    public int getValue() {
	return spinner.getValue();
    }
}
