/*
 * smi/awt/JSpinnerUI.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.awt;

import javax.swing.JComponent;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Color;
import java.awt.Dimension;

class JSpinnerUI extends BasicSpinnerUI {
    public void paint(Graphics g, JComponent c) {
	Spinner spinner = ((Spinner)(c));
	//frosty man, frosty
	getMinimumSize(c); //Force computation of dimension
	Insets bi = spinner.getBorder().getBorderInsets(spinner);
	if (spinner.hasFocus()) {
	    g.setColor(new Color(0,0,128));
	    g.fillRect(bi.left, bi.top, d.width-(bi.left+bi.right), d.height-(bi.top+bi.bottom));
	    g.setColor(Color.white);
	} else {
	    g.setColor(Color.white);
	    g.fillRect(bi.left, bi.top, d.width-(bi.left+bi.right), d.height-(bi.top+bi.bottom));
	    g.setColor(Color.black);
	}
	String s= Integer.toString(spinner.getValue());
	g.drawString(s, d.width-fm.stringWidth(s) - bi.right, ascent + bi.bottom);
    }

    public Dimension getPreferredSize(JComponent c) {
	return getMinimumSize(c);
    }

    public Dimension getMaximumSize(JComponent c) {
	return getMinimumSize(c);
    }

    public Dimension getMinimumSize(JComponent c) {
	Spinner s = ((Spinner)(c));
	fm = s.getFontMetrics(s.getFont());
	int w=0;
	w = fm.stringWidth("0")*s.getDigits();
	if (s.getText()!=null)
	    w+=fm.stringWidth(s.getText());
	Insets bi = s.getBorder().getBorderInsets(s);
	d = new Dimension(w+bi.left+bi.right, fm.getHeight()+bi.top+bi.bottom-1);
	ascent = fm.getAscent();
	return d;
    }
}
