
/**
 * Title:        3.Versuch<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Jens<p>
 * Company:      TUD/INF/IKT<p>
 * @author Jens
 * @version 1.0
 */
package smi.baseConf;

import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Dimension;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Hashtable;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Iterator;
import java.util.Collection;

import javax.swing.*;
import javax.swing.event.*;

import smi.awt.AppletFrame;
import smi.awt.JPreferenceList;
import smi.awt.Ping;
import smi.baseConf.RatedString;
import smi.baseConf.CancelException;
import smi.mechanisms.Mechanism;
import smi.mechanisms.MechanismConfiguration;
import smi.mechanisms.ParameterNotCompatibleException;
import smi.io.IOStream;

import help.Help;



// fr Diplom
//import participant.Participant;
//import goalsConfig.mechConfig.LEPanel;
import smi.baseConf.BaseConfiguration;
//import smi.baseConf.StartUp;

public class ConfigurationAccountability extends JTabbedPane implements ActionListener{

public JPreferenceList accountabilitySignPreferenceList, accountabilityAcceptSignPreferenceList;
private AppletFrame parentFrame;
public Hashtable accountabilityConfiguration;
private static ResourceBundle accresource;
private String changeConfigurationButtonTextKey = "DETAIL";
private JCheckBox askBeforeSignCheckBox;
private JTabbedPane accountabilityTabbedPane;
private JRadioButton accountabilitySignRadioButton = new JRadioButton();
private JRadioButton accountabilityAcceptRadioButton = new JRadioButton();
// Verzeichnis mit Konfigurationseinstellungen
private String configDir;
private String user;
private static String configFileName = "AccountabilityConfig.object";
////////////////////////////////////////////////////////////////////////////////
//verfgbare Mechanismen auslesen
private BufferedReader availableFile = null;
////////////////////////////////////////////////////////////////////////////////
//Zum Auslesen der verfgbaren Mechanismen
private String[] accountabilityMechanisms;
////////////////////////////////////////////////////////////////////////////////
//initialize()
private JButton[] changeConfigurationButton = new JButton[2];
private JButton[] helpButton = new JButton[2];
////////////////////////////////////////////////////////////////////////////////
//changeResource()
private static Help hp;
////////////////////////////////////////////////////////////////////////////////

  public ConfigurationAccountability(AppletFrame parentFrame, String configDir,
                            String user, Hashtable sign)
  {
       this.parentFrame = parentFrame;
       this.configDir = configDir ;
       this.user = user;
       this.accountabilityConfiguration = sign;
    //   readConfig();


        try{
            availableFile = new BufferedReader(new FileReader(System.getProperty("ssonet_cfg")+
                                                           "smi/mechanisms/accavailable.dat")) ;
                 }//try
                        catch (FileNotFoundException fnfe)
                        {
                        System.out.println (System.getProperty ("ssonet_cfg")+"smi/mechanisms/accavailable.dat not found.");
	                System.exit (-1);
                        }//catch

               String s ;
               s = "";
	     try {
	           while ((s.trim() == "") || ((s.trim()).charAt(0) == '#'))
	         {
		   s = availableFile.readLine();
                   System.out.println(s);
	          }//while
	          }//try
                      catch (IOException ioe) {
	          s = "";
	                 }//catch
                  accountabilityMechanisms = getTokenized(s);
                  initialize();
  }

   private String[] getTokenized (String s) {
	StringTokenizer st = new StringTokenizer(s);
	String[] ret = new String[st.countTokens()];
	int i = 0;
	while (st.hasMoreTokens()) {
	    ret[i++] = st.nextToken();
	}
	return ret;
    }


  public void actionPerformed(ActionEvent event)
  {
  if(event.getSource() == helpButton[0])
       {    //Sign
	    String str = (String)accountabilitySignPreferenceList.getList().getSelectedValue(); //rechte Liste
	    if(str == null)
		str = (String)accountabilitySignPreferenceList.getPreferenceList().getSelectedValue();//linke Liste
	    viewHelp("ACCOUNTABILITY",str);
	}//if
   else if (event.getSource() == helpButton[1])
   {
   //Accountability Accept
	    String str = (String)accountabilityAcceptSignPreferenceList.getList().getSelectedValue(); //rechte Liste
	    if(str == null)
		str = (String)accountabilityAcceptSignPreferenceList.getPreferenceList().getSelectedValue();//linke Liste
	    viewHelp("ACCOUNTABILITY",str);
   }//else if
   else if(event.getSource()== changeConfigurationButton[0])
   {
   try{
		String mechanismName = (String)accountabilitySignPreferenceList.getPreferenceList().getSelectedValue();
		Mechanism mechanism = (Mechanism)Class.forName
		    ("smi.mechanisms.accountability." + mechanismName).newInstance();
		MechanismConfiguration mechanismConfiguration = mechanism.configDetail
		    (parentFrame,
		     (MechanismConfiguration)accountabilityConfiguration.get("signatures.sign." + mechanismName + ".configuration"));
		System.out.println(mechanismConfiguration);
		accountabilityConfiguration.put("signatures.sign." + mechanismName + ".configuration",mechanismConfiguration);
	    } catch(Exception e) {
		e.printStackTrace();
	    }//catch
   }//else if
   else if(event.getSource() == changeConfigurationButton[1])
   {
    try{
		String mechanismName = (String)accountabilityAcceptSignPreferenceList.getPreferenceList().getSelectedValue();
		Mechanism mechanism = (Mechanism)Class.forName
		    ("smi.mechanisms.accountability." + mechanismName).newInstance();
		MechanismConfiguration mechanismConfiguration = mechanism.configDetail
		    (parentFrame,
		     (MechanismConfiguration)accountabilityConfiguration.get("signatures.accept." + mechanismName + ".configuration"));
		System.out.println(mechanismConfiguration);
		accountabilityConfiguration.put("signatures.accept." + mechanismName + ".configuration",mechanismConfiguration);
	    } catch(Exception e) {
		e.printStackTrace();
	    }//catch
   }//else if
  }//method

   public static void viewHelp(String str1, String str2) {

	if (hp != null) {
	    hp.vanishWindow();
	}
	hp = new Help(System.getProperty("ssonet_help"));
	hp.viewPage (str1,str2);
    }

 public void writeConfig ()
   {
   // schreibt KonfigurationsDatei in Alf (IntegrityMech)

   try{
            String[] accSignMechs, accAcceptMechs;
            accSignMechs = accountabilitySignPreferenceList.getPreferenceListItems();
            for (int i =0; i < accSignMechs.length; i++){
            System.out.println("Preferences:"+accSignMechs[i]);}
            accountabilityConfiguration.put("preflist.accountability.sign",accSignMechs);
            accAcceptMechs = accountabilityAcceptSignPreferenceList.getPreferenceListItems();
            accountabilityConfiguration.put("preflist.accountability.accept",accAcceptMechs);
	    //Konfiguration in Datei schreiben.
	    FileOutputStream fos = new FileOutputStream(configDir+user+configFileName);
	    ObjectOutputStream oos = new ObjectOutputStream((OutputStream)fos);
            oos.writeObject(accountabilityConfiguration);
	    oos.close();
	    fos.close();
	}
	catch (Exception e){
	    System.out.println("Fehler: Konfigurationsdatei Zurechenbarkeit "
			       +"kann nicht geschrieben werden!");
	}//catch
 }//method

  public void changeUser(String user)
    {
    this.user = user;
    }


  public void readConfig(){
	boolean configIsValid = true;
	try{
	    FileInputStream fis = new FileInputStream(configDir+user+configFileName);
	    ObjectInputStream ois = new ObjectInputStream(fis);
	    accountabilityConfiguration = (Hashtable)ois.readObject();

	    ois.close();
	    fis.close();
	}
	catch (Exception e){
	    System.out.println("Konfigurationsdatei fr Zurechenbarkeitsmechanismen "
			       +"nicht gefunden! Benutze Standardwerte.");
	    configIsValid = false;
	}
 }

  public void initialize()
  {
        GridBagLayout gridBagLayout = new GridBagLayout();
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
         // Panel create Signatures
        /////////////////////////////////////////////////////////////////////////////
        JPanel createSignaturesPanel = new JPanel();

        createSignaturesPanel.setLayout(gridBagLayout);
        createSignaturesPanel.setDoubleBuffered(false);

        accountabilitySignPreferenceList =
	    new JPreferenceList(12,
	    (String[])accountabilityConfiguration.get("preflist.accountability.sign"),
	    accountabilityMechanisms);
        gridBagConstraints.insets = new Insets(5,5,0,10);
        gridBagConstraints.anchor = GridBagConstraints.CENTER;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1;
        gridBagConstraints.weighty = 1;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagLayout.setConstraints(accountabilitySignPreferenceList, gridBagConstraints);
        createSignaturesPanel.add(accountabilitySignPreferenceList);

	JPanel buttonAccoSignPanel = new JPanel();
        buttonAccoSignPanel.setLayout(new BoxLayout(buttonAccoSignPanel,BoxLayout.X_AXIS));
	changeConfigurationButton[0] = new JButton();
        changeConfigurationButton[0].setEnabled(false);
        gridBagConstraints.insets = new Insets(10,25,0,0);
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        gridBagConstraints.fill = GridBagConstraints.NONE;
        gridBagConstraints.weightx = 0;
        gridBagConstraints.weighty = 0;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagLayout.setConstraints(buttonAccoSignPanel, gridBagConstraints);
        buttonAccoSignPanel.add(changeConfigurationButton[0]);
        changeConfigurationButton[0].addActionListener(this);
        new PreferenceListSelectionListener(accountabilitySignPreferenceList.getPreferenceList(),
	    accountabilitySignPreferenceList.getList(),
	    changeConfigurationButton[0]);
	buttonAccoSignPanel.add(Box.createRigidArea(new Dimension(100,1)));
	helpButton[0] = new JButton();
	helpButton[0].addActionListener(this);
	buttonAccoSignPanel.add(helpButton[0]);
        createSignaturesPanel.add(buttonAccoSignPanel);

        askBeforeSignCheckBox = new JCheckBox("",true);
        gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new Insets(5,5,0,0);
        gridBagConstraints.fill = GridBagConstraints.NONE;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagLayout.setConstraints(askBeforeSignCheckBox, gridBagConstraints);
        createSignaturesPanel.add(askBeforeSignCheckBox);
/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

        // Panel accept Signatures
        JPanel acceptSignaturesPanel = new JPanel();

        acceptSignaturesPanel.setLayout(gridBagLayout);
        acceptSignaturesPanel.setDoubleBuffered(false);

        accountabilityAcceptSignPreferenceList =
	    new JPreferenceList(12,
	    (String[])accountabilityConfiguration.get("preflist.accountability.accept"),
	    accountabilityMechanisms);
        gridBagConstraints.anchor = GridBagConstraints.CENTER;
        gridBagConstraints.insets = new Insets(5,5,0,10);
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1;
        gridBagConstraints.weighty = 1;
         gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagLayout.setConstraints(accountabilityAcceptSignPreferenceList, gridBagConstraints);
        acceptSignaturesPanel.add(accountabilityAcceptSignPreferenceList);

        JPanel buttonAccoAcceptPanel = new JPanel();
        buttonAccoAcceptPanel.setLayout(new BoxLayout(buttonAccoAcceptPanel,BoxLayout.X_AXIS));
	changeConfigurationButton[1] = new JButton("CHANGE");
        changeConfigurationButton[1].setEnabled(false);
        changeConfigurationButton[1].addActionListener(this);
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        gridBagConstraints.insets = new Insets(10,25,10,0);
        gridBagConstraints.insets.left = 20;
        gridBagConstraints.insets.top = 10;
        gridBagConstraints.fill = GridBagConstraints.NONE;
        gridBagConstraints.weightx = 0;
        gridBagConstraints.weighty = 0;
         gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagLayout.setConstraints(buttonAccoAcceptPanel, gridBagConstraints);
        buttonAccoAcceptPanel.add(changeConfigurationButton[1]);
        new PreferenceListSelectionListener(accountabilityAcceptSignPreferenceList.getPreferenceList(),
	    accountabilityAcceptSignPreferenceList.getList(),
	    changeConfigurationButton[1]);
        buttonAccoAcceptPanel.add(Box.createRigidArea(new Dimension(100,1)));
	helpButton[1] = new JButton();
	helpButton[1].addActionListener(this);
	buttonAccoAcceptPanel.add(helpButton[1]);
        acceptSignaturesPanel.add(buttonAccoAcceptPanel);

        /////////////////////////////////////////////////////////////////////////
       // accountabilityTabbedPane = new JTabbedPane();
        this.add(createSignaturesPanel);
        this.add(acceptSignaturesPanel);
        //accoutabilityTabbedPane.setSize(200,200);
      //  this.add(accountabilityTabbedPane);
        accresource = ResourceBundle.getBundle("smi.baseConf.locale.Resources",Locale.GERMAN);
        changeResource(accresource);
  }


   public void changeLanguage(Locale language)
 {
	    accresource = ResourceBundle.getBundle("smi.baseConf.locale.Resources", language);
	    changeResource(accresource);
 }

 private void changeResource(ResourceBundle accresource)
 {
 for(int i = 0;i < changeConfigurationButton.length;i++)
            changeConfigurationButton[i].setText(accresource.getString(changeConfigurationButtonTextKey));
	for(int i = 0;i < helpButton.length;i++)
            helpButton[i].setText(accresource.getString("HELP"));
   //      changeConfigurationButton[0].setText(accresource.getString(changeConfigurationButtonTextKey));
   //      changeConfigurationButton[1].setText(accresource.getString(changeConfigurationButtonTextKey));
         this.setTitleAt(0,accresource.getString("CREATE_SIGNATURES"));
        this.setTitleAt(1,accresource.getString("ACCEPT_SIGNATURES"));
          accountabilitySignPreferenceList.setHeader(accresource.getString("PREFERENCELIST"),
	    accresource.getString("AVAILABLE_MECHANISMS"));

        accountabilityAcceptSignPreferenceList.setHeader(accresource.getString("PREFERENCELIST"),
	    accresource.getString("AVAILABLE_MECHANISMS"));
        askBeforeSignCheckBox.setText(accresource.getString("ASK_BEFORE_SIGN"));

        //RadioButtons
        accountabilitySignRadioButton.setText(accresource.getString("CREATE_SIGNATURES"));
        accountabilityAcceptRadioButton.setText(accresource.getString("ACCEPT_SIGNATURES"));
 }//method

  public static Hashtable getConfigurationAccountability() {
	try {
	    return (Hashtable)(new ObjectInputStream(new FileInputStream
		(new File(System.getProperty("ssonet_cfg")+"users/"+System.getProperty("ssonet_userdir"),
		"AccountabilityConfig.object")))).readObject();
	} catch(Exception e) {
	    return null;
	}
    }

  public static void main(String[] args)
  {
 /*  AppletFrame testFrame = new AppletFrame("Test");
   ConfigurationAccountability ca = new ConfigurationAccountability(testFrame,  "C:/Jens/program/users/Alf/",
    new Hashtable());
    testFrame.getContentPane().add(ca);
    testFrame.pack();
    testFrame.show();*/
  }

}

