
/**
 * Title:        3.Versuch<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Jens<p>
 * Company:      TUD/INF/IKT<p>
 * @author Jens
 * @version 1.0
 */
package smi.baseConf;

import cryptix.provider.rsa.RawRSAPublicKey;

import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Dimension;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Hashtable;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Iterator;
import java.util.Collection;

import javax.swing.*;
import javax.swing.event.*;

import smi.awt.AppletFrame;
import smi.awt.JPreferenceList;
import smi.awt.Ping;
import smi.baseConf.RatedString;
import smi.baseConf.CancelException;
import smi.mechanisms.Mechanism;
import smi.mechanisms.MechanismConfiguration;
import smi.mechanisms.ParameterNotCompatibleException;
import smi.io.IOStream;

/*import smi.util.SSONETConstants;
import smi.util.KeyExchange;
import smi.util.IdentityCheck;
import smi.help.Help;
import smi.gateway.GatewayWindow;*/
import help.Help;


// fr Diplom
//import participant.Participant;
//import goalsConfig.mechConfig.LEPanel;
import smi.baseConf.BaseConfiguration;


public class ConfigurationAnonymity extends JPanel implements ActionListener, ListSelectionListener {

public JPreferenceList anonymityPreferenceList;
private AppletFrame parentFrame;
private JLabel anonymityPanelLabel;
///////////////////////////////////////////////////////////////////////////////
public Hashtable anonymityConfiguration;
private String[] list;
private static ResourceBundle anonresource;
///////////////////////////////////////////////////////////////////////////////
// Verzeichnis mit Konfigurationseinstellungen
private String configDir;
private String user;
private static String configFileName = "AnonymityConfig.object";
////////////////////////////////////////////////////////////////////////////////
//verfgbare Mechanismen auslesen
private BufferedReader availableFile = null;
////////////////////////////////////////////////////////////////////////////////
//Zum Auslesen der verfgbaren Mechanismen
private String[] anonymityMechanisms;
////////////////////////////////////////////////////////////////////////////////
//initialize()
private JButton helpButton = new JButton("HELP");
////////////////////////////////////////////////////////////////////////////////
//changeResource()
private static Help hp;
////////////////////////////////////////////////////////////////////////////////

  public ConfigurationAnonymity(AppletFrame parentFrame, String configDir,String user, Hashtable anonymityConfiguration)
  {
         this.parentFrame = parentFrame;
         this.configDir = configDir;
         this.user = user;
         this.anonymityConfiguration = anonymityConfiguration;
         System.out.println(user);
    //     readConfig();
         System.out.println("Konstruktor");

    try{
            availableFile = new BufferedReader(new FileReader(System.getProperty("ssonet_cfg")+
                                                           "smi/mechanisms/anonavailable.dat")) ;
                 }//try
                        catch (FileNotFoundException fnfe)
                        {
                        System.out.println (System.getProperty ("ssonet_cfg")+"smi/mechanisms/anonavailable.dat not found.");
	                System.exit (-1);
                        }//catch

               String s ;
               s = "";
	     try {
	           while ((s.trim() == "") || ((s.trim()).charAt(0) == '#'))
	         {
		   s = availableFile.readLine();
                   System.out.println(s);
	          }//while
	          }//try
                      catch (IOException ioe) {
	          s = "";
	                 }//catch
	         anonymityMechanisms = getTokenized (s);
                 initialize();
  }

// Methode getTokenized() aus StartUp fr auslesen der verfgbaren Mechanismen
  private String[] getTokenized (String s)
     {
	StringTokenizer st = new StringTokenizer(s);
	String[] ret = new String[st.countTokens()];
	int i = 0;
	while (st.hasMoreTokens()) {
	    ret[i++] = st.nextToken();
	}
	return ret;
     }//getTokenized()

  public void actionPerformed(ActionEvent event)
  {
    if(event.getSource() == helpButton) {
	    //Anonymity
	    String str = (String)anonymityPreferenceList.getList().getSelectedValue(); //rechte Liste
	    if(str == null)
		str = (String)anonymityPreferenceList.getPreferenceList().getSelectedValue();//linke Liste
	    viewHelp("ANONYMITY",str);
	}
  }

   public static void viewHelp(String str1, String str2) {

	if (hp != null) {
	    hp.vanishWindow();
	}
	hp = new Help(System.getProperty("ssonet_help"));
	hp.viewPage (str1,str2);
    }

  public void valueChanged(ListSelectionEvent event){}

  private void initialize()
  {
          GridBagLayout gridBagLayout = new GridBagLayout();
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
    //    setBackground(Color.lightGray);
     //  JPanel anonymityPanel = new JPanel();
        this.setLayout(gridBagLayout);
        anonymityPanelLabel = new JLabel();
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        gridBagConstraints.insets = new Insets(5,10,0,0);
        gridBagConstraints.fill = GridBagConstraints.NONE;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagLayout.setConstraints(anonymityPanelLabel, gridBagConstraints);
        this.add(anonymityPanelLabel);


        anonymityPreferenceList = new JPreferenceList(12,
	    (String[])anonymityConfiguration.get("preflist.anonymity"),
	    anonymityMechanisms);
        gridBagConstraints.anchor = GridBagConstraints.CENTER;
        gridBagConstraints.insets = new Insets(5,10,0,10);
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1;
        gridBagConstraints.weighty = 1;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagLayout.setConstraints(anonymityPreferenceList, gridBagConstraints);
        this.add(anonymityPreferenceList);


        JPanel buttonAnonPanel = new JPanel();
        buttonAnonPanel.setLayout(new BoxLayout(buttonAnonPanel,BoxLayout.X_AXIS));
	gridBagConstraints.anchor = GridBagConstraints.WEST;
        gridBagConstraints.insets = new Insets(15,30,15,0);
        gridBagConstraints.weightx = 0;
        gridBagConstraints.weighty = 0;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = GridBagConstraints.NONE;
        gridBagLayout.setConstraints(buttonAnonPanel, gridBagConstraints);
        buttonAnonPanel.add(Box.createRigidArea(new Dimension(260,1)));
	//helpButton[4] = new JButton();
	helpButton.addActionListener(this);
	buttonAnonPanel.add(helpButton);
        this.add(buttonAnonPanel);
        //Resource
        anonresource = ResourceBundle.getBundle("smi.baseConf.locale.Resources",Locale.GERMAN);
        changeResource(anonresource);

  }

    public void changeUser(String user)
    {
    this.user = user;
    }

    public void writeConfig ()
   {
   // schreibt KonfigurationsDatei in Alf (IntegrityMech)

   try{     String[] anonMechs;
            anonMechs = anonymityPreferenceList.getPreferenceListItems();
            for (int i =0; i < anonMechs.length; i++){
            System.out.println("Preferences:"+anonMechs[i]);}
             anonymityConfiguration.put("preflist.anonymity",anonMechs);
	    //Konfiguration in Datei schreiben.
	    FileOutputStream fos = new FileOutputStream(configDir+user+configFileName);
	    ObjectOutputStream oos = new ObjectOutputStream((OutputStream)fos);
            oos.writeObject(anonymityConfiguration);
	    oos.close();
	    fos.close();
	}
	catch (Exception e){
	    System.out.println("Fehler: Konfigurationsdatei "
			       +"kann nicht geschrieben werden!");
	}//catch
 }


 // Auslesen der Konfiguration der Integritt
 public void readConfig(){
	boolean configIsValid = true;
	try{
	    FileInputStream fis = new FileInputStream(configDir+user+configFileName);
            System.out.println(configDir+user+configFileName+" readConfig() Anon");
	    ObjectInputStream ois = new ObjectInputStream(fis);
	    anonymityConfiguration = (Hashtable)ois.readObject();

	    ois.close();
	    fis.close();
	}
	catch (Exception e){
	    System.out.println("Konfigurationsdatei fr Mixe (Anonymitt) "
			       +"nicht gefunden! Benutze Standardwerte.");
	    configIsValid = false;
	}
 }

 public void changeLanguage(Locale language)
 {
	    anonresource = ResourceBundle.getBundle("smi.baseConf.locale.Resources", language);
	    changeResource(anonresource);
 }

 private void changeResource(ResourceBundle anonresource)
 {
 helpButton.setText(anonresource.getString("HELP"));
 anonymityPanelLabel.setText(anonresource.getString("USEAGE_OF_MIXES"));
 anonymityPreferenceList.setHeader(anonresource.getString("CHOSEN_ROUTE"),
	    anonresource.getString("AVAILABLE_MIXES"));
 }

/*  public static Hashtable getConfigurationAnonymity() {
	try {
	    return (Hashtable)(new ObjectInputStream(new FileInputStream
		(new File(System.getProperty("ssonet_cfg")+"users/"+System.getProperty("ssonet_userdir"),
		"AnonymityConfig.object")))).readObject();
	} catch(Exception e) {
	    return null;
	}
    }*/

  public static void main(String[] args)
  {
  /* AppletFrame testFrame = new AppletFrame("Test");
   ConfigurationAnonymity ca = new ConfigurationAnonymity(testFrame,  "C:/Jens/program/users/Alf/",
    new Hashtable());
    testFrame.getContentPane().add(ca);
    testFrame.pack();
    testFrame.show();*/
  }

}