
/**
 * Title:        3.Versuch<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Jens<p>
 * Company:      TUD/INF/IKT<p>
 * @author Jens
 * @version 1.0
 */
package smi.baseConf;

import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Dimension;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Hashtable;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Iterator;
import java.util.Collection;

import javax.swing.*;
import javax.swing.event.*;

import smi.awt.AppletFrame;
import smi.awt.JPreferenceList;
import smi.awt.Ping;
import smi.baseConf.RatedString;
import smi.baseConf.CancelException;
import smi.mechanisms.Mechanism;
import smi.mechanisms.MechanismConfiguration;
import smi.mechanisms.ParameterNotCompatibleException;
import smi.io.IOStream;

/*import smi.util.SSONETConstants;
import smi.util.KeyExchange;
import smi.util.IdentityCheck;
import smi.help.Help;
import smi.gateway.GatewayWindow;*/
import help.Help;

// fr Diplom
//import participant.Participant;
//import goalsConfig.mechConfig.LEPanel;
import smi.baseConf.BaseConfiguration;

public class ConfigurationConfidentiality extends JPanel implements ActionListener{

public JPreferenceList confidentialityPreferenceList;
private AppletFrame parentFrame;
private JLabel confidentialityPanelLabel;
////////////////////////////////////////////////////////////////////////////////
public Hashtable confidentialityConfiguration;
private String[] list;
private static ResourceBundle conresource;
// Verzeichnis mit Konfigurationseinstellungen
private String configDir;
private String user;
private static String configFileName = "ConfidentialityConfig.object";
////////////////////////////////////////////////////////////////////////////////
//verfgbare Mechanismen auslesen
private BufferedReader availableFile = null;
////////////////////////////////////////////////////////////////////////////////
//Zum Auslesen der verfgbaren Mechanismen
private String[] confidentialityMechanisms;
////////////////////////////////////////////////////////////////////////////////
//initialize()
private JButton changeConfigurationButton = new JButton("CHANGE");
private JButton helpButton = new JButton("HELP");
////////////////////////////////////////////////////////////////////////////////
//changeResource()
private static Help hp;
////////////////////////////////////////////////////////////////////////////////
private String changeConfigurationButtonTextKey = "DETAIL";

  public ConfigurationConfidentiality(AppletFrame parentFrame, String configDir,
                                String user, Hashtable confidentialityConfiguration)
  {
               this.parentFrame = parentFrame;
               this.configDir = configDir;
               this.user = user;
               this.confidentialityConfiguration = confidentialityConfiguration;
            //   readConfig();

     try{
            availableFile = new BufferedReader(new FileReader(System.getProperty("ssonet_cfg")+
                                                           "smi/mechanisms/conavailable.dat")) ;
                 }//try
                        catch (FileNotFoundException fnfe)
                        {
                        System.out.println (System.getProperty ("ssonet_cfg")+"smi/mechanisms/conavailable.dat not found.");
	                System.exit (-1);
                        }//catch

               String s ;
               s = "";
	     try {
	           while ((s.trim() == "") || ((s.trim()).charAt(0) == '#'))
	         {
		   s = availableFile.readLine();
                   System.out.println(s);
	          }//while
	          }//try
                      catch (IOException ioe) {
	          s = "";
	                 }//catch
	         confidentialityMechanisms = getTokenized (s);
                 initialize();
  }


   private String[] getTokenized (String s) {
	StringTokenizer st = new StringTokenizer(s);
	String[] ret = new String[st.countTokens()];
	int i = 0;
	while (st.hasMoreTokens()) {
	    ret[i++] = st.nextToken();
	}
	return ret;
    }

  public void actionPerformed (ActionEvent event)
  {
   if(event.getSource() == helpButton)
       {
	    //Confidentiality
	    String str = (String)confidentialityPreferenceList.getList().getSelectedValue(); //rechte Liste
	    if(str == null)
		str = (String)confidentialityPreferenceList.getPreferenceList().getSelectedValue();//linke Liste
	    viewHelp("CONFIDENTIALITY",str);
	}//if
        else if(event.getSource() == changeConfigurationButton) {
	    try{
		String mechanismName = (String)confidentialityPreferenceList.getPreferenceList().getSelectedValue();
		Mechanism mechanism = (Mechanism)Class.forName("smi.mechanisms.confidentiality." + mechanismName).newInstance();
		MechanismConfiguration mechanismConfiguration = mechanism.configDetail
		    (parentFrame,
		     (MechanismConfiguration)confidentialityConfiguration.get("confidentiality." + mechanismName + ".configuration"));
		System.out.println(mechanismConfiguration);
		confidentialityConfiguration.put("confidentiality." + mechanismName + ".configuration",mechanismConfiguration);
	    } catch(Exception e) {
		e.printStackTrace();
	    }//catch
     }//if
  }//method

   public static void viewHelp(String str1, String str2) {

	if (hp != null) {
	    hp.vanishWindow();
	}
	hp = new Help(System.getProperty("ssonet_help"));
	hp.viewPage (str1,str2);
    }

    public void initialize()
    {
     GridBagLayout gridBagLayout = new GridBagLayout();
        GridBagConstraints gridBagConstraints = new GridBagConstraints();

      //  JPanel confidentialityPanel = new JPanel();
        this.setLayout(gridBagLayout);

        // Label ...
        confidentialityPanelLabel = new JLabel();
        gridBagConstraints.insets = new Insets(5,10,0,0);
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = GridBagConstraints.NONE;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagLayout.setConstraints(confidentialityPanelLabel, gridBagConstraints);
        this.add(confidentialityPanelLabel);


        gridBagConstraints.anchor = GridBagConstraints.CENTER;
        gridBagConstraints.insets = new Insets(5,10,0,10);
        gridBagConstraints.weightx = 1;
        gridBagConstraints.weighty = 1;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        confidentialityPreferenceList = new JPreferenceList(12,
	    (String[])confidentialityConfiguration.get("preflist.confidentiality"),
	    confidentialityMechanisms);
        gridBagLayout.setConstraints(confidentialityPreferenceList, gridBagConstraints);
        this.add(confidentialityPreferenceList);

	JPanel buttonConfPanel = new JPanel();
	buttonConfPanel.setLayout(new BoxLayout(buttonConfPanel,BoxLayout.X_AXIS));
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        gridBagConstraints.insets = new Insets(15,30,15,0);
        gridBagConstraints.weightx = 0;
        gridBagConstraints.weighty = 0;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = GridBagConstraints.NONE;
        gridBagLayout.setConstraints(buttonConfPanel, gridBagConstraints);
        buttonConfPanel.add(changeConfigurationButton);
        changeConfigurationButton.addActionListener(this);
        changeConfigurationButton.setEnabled(false);
        changeConfigurationButton.setToolTipText("Click to configure the selected mechanism.");
        new PreferenceListSelectionListener(confidentialityPreferenceList.getPreferenceList(),
	    confidentialityPreferenceList.getList(),
	    changeConfigurationButton);
	buttonConfPanel.add(Box.createRigidArea(new Dimension(100,1)));
	helpButton.addActionListener(this);
	buttonConfPanel.add(helpButton);
        this.add(buttonConfPanel);
        //Resource
        conresource = ResourceBundle.getBundle("smi.baseConf.locale.Resources",Locale.GERMAN);
        changeResource(conresource);
    }

     public void changeLanguage(Locale language)
 {
	    conresource = ResourceBundle.getBundle("smi.baseConf.locale.Resources", language);
	    changeResource(conresource);
 }

  private void changeResource(ResourceBundle conresource)
  {
    changeConfigurationButton.setText(conresource.getString(changeConfigurationButtonTextKey));
    helpButton.setText(conresource.getString("HELP"));
    confidentialityPanelLabel.setText(conresource.getString("CHIPHER_MESSAGES"));
    confidentialityPreferenceList.setHeader(conresource.getString("PREFERENCELIST"),
	    conresource.getString("AVAILABLE_MECHANISMS"));

  }

    public void writeConfig ()
   {
   // schreibt KonfigurationsDatei in Alf (IntegrityMech)

   try{     String[] conMechs;
            conMechs = confidentialityPreferenceList.getPreferenceListItems();
            for (int i =0; i < conMechs.length; i++){
            System.out.println("Preferences:"+conMechs[i]);}
             confidentialityConfiguration.put("preflist.confidentiality",conMechs);
	    //Konfiguration in Datei schreiben.
	    FileOutputStream fos = new FileOutputStream(configDir+user+configFileName);
	    ObjectOutputStream oos = new ObjectOutputStream((OutputStream)fos);
            oos.writeObject(confidentialityConfiguration);
	    oos.close();
	    fos.close();
	}
	catch (Exception e){
	    System.out.println("Fehler: Konfigurationsdatei "
			       +"kann nicht geschrieben werden!");
	}//catch
 }

    public void changeUser(String user)
    {
    this.user = user;
    }


     // Auslesen der Konfiguration der Vertraulichkeit
      public void readConfig()
      {
	boolean configIsValid = true;
	try{
	    FileInputStream fis = new FileInputStream(configDir+user+configFileName);
	    ObjectInputStream ois = new ObjectInputStream(fis);
	    confidentialityConfiguration = (Hashtable)ois.readObject();

	    ois.close();
	    fis.close();
	}
	catch (Exception e)
           {
	    System.out.println("Konfigurationsdatei Vertraulichkeit "
			       +"nicht gefunden! Benutze Standardwerte.");
	    configIsValid = false;
	    }
 }

  public static Hashtable getConfigurationConfidentiality() {
	try {
            File confFile = new File(System.getProperty("ssonet_cfg")+"users/"+System.getProperty("ssonet_userdir"),
		"ConfidentialityConfig.object");

	    return (Hashtable)((new ObjectInputStream(new FileInputStream(confFile))).readObject());
	} catch(Exception e) {
            e.printStackTrace();
	    return null;
	}
    }

  public static void main(String[] args)
  {
 /*  AppletFrame testFrame = new AppletFrame("Test");
   ConfigurationConfidentiality cc = new ConfigurationConfidentiality(testFrame,  "C:/Jens/program/users/Alf/",
    new Hashtable());
    testFrame.getContentPane().add(cc);
    testFrame.pack();
    testFrame.show();*/
  }
}