
/**
 * Title:        TempConfig<p>
 * Description:  zweiter Versuch<p>
 * Copyright:    Copyright (c) Jens<p>
 * Company:      TUD<p>
 * @author Jens
 * @version 1.0
 * Soll Funktionalitt von BaseConfiguration bernehmen.
 */
package smi.baseConf;

import cryptix.provider.rsa.RawRSAPublicKey;

import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Dimension;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Hashtable;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Iterator;
import java.util.Collection;

import javax.swing.*;
import javax.swing.event.*;

import smi.awt.AppletFrame;
import smi.awt.JPreferenceList;
import smi.awt.Ping;
import smi.baseConf.RatedString;
import smi.baseConf.CancelException;
import smi.mechanisms.Mechanism;
import smi.mechanisms.MechanismConfiguration;
import smi.mechanisms.ParameterNotCompatibleException;
import smi.io.IOStream;


import help.Help;


import smi.baseConf.BaseConfiguration;

public class ConfigurationIntegrity extends JPanel implements ActionListener,ListSelectionListener {

public JPreferenceList integrityPreferenceList;
//Anzeigekomponenten
private AppletFrame parentFrame;
private JButton okButton;
private JButton cancelButton;
private JLabel integrityPanelLabel;// in initialize()
///////////////////////////////////////////////////////////////////////////////
public Hashtable integrityConfiguration;
private String[] list;
private static ResourceBundle intresource;//changeResource und actionPerformed
private String changeConfigurationButtonTextKey = "DETAIL";

// Verzeichnis mit Konfigurationseinstellungen
private String configDir;
private String user;
private static String configFileName = "IntegrityConfig.object";
////////////////////////////////////////////////////////////////////////////////
//verfgbare Mechanismen auslesen
private BufferedReader availableFile = null;
////////////////////////////////////////////////////////////////////////////////
//Zum Auslesen der verfgbaren Mechanismen
private String[] integrityMechanisms;
////////////////////////////////////////////////////////////////////////////////
// in initialize()
private JTabbedPane tabbedPane;
////////////////////////////////////////////////////////////////////////////////
//initialize()
private JButton changeConfigurationButton = new JButton("CHANGE");
private JButton helpButton = new JButton("HELP");
////////////////////////////////////////////////////////////////////////////////
//changeResource()
private static Help hp;
////////////////////////////////////////////////////////////////////////////////
  public ConfigurationIntegrity(AppletFrame parentFrame, String configDir,
                                 String user, Hashtable integrityConfiguration)
      {
           this.parentFrame = parentFrame;
           this.configDir = configDir;
           this.user = user;
           this.integrityConfiguration = integrityConfiguration;
     //      readConfig(); Konfiguration einlesen

// Funktionalitt von StartUp.run() im Konstruktor --> Auslesen der verfgbaren Mechanismen
            try{
            availableFile = new BufferedReader(new FileReader(System.getProperty("ssonet_cfg")+
                                                           "smi/mechanisms/intavailable.dat")) ;
                 }//try
                        catch (FileNotFoundException fnfe)
                        {
                        System.out.println (System.getProperty ("ssonet_cfg")+"smi/mechanisms/intavailable.dat not found.");
	                System.exit (-1);
                        }//catch

               String s ;
               s = "";
	     try {
	           while ((s.trim() == "") || ((s.trim()).charAt(0) == '#'))
	         {
		   s = availableFile.readLine();
                   System.out.println(s);
	          }//while
	          }//try
                      catch (IOException ioe) {
	          s = "";
	                 }//catch
	         integrityMechanisms = getTokenized (s);
 // configFile erzeugen


                 initialize();

  }
// BaseConfig.ButtonPanel
   public void actionPerformed (ActionEvent event)
   {
// aus zweiter actionPerformed --> baseconfiguration

          if(event.getSource() == changeConfigurationButton) {
	    try{
		String mechanismName = (String)integrityPreferenceList.getPreferenceList().getSelectedValue();
		Mechanism mechanism = (Mechanism)Class.forName("smi.mechanisms.integrity." + mechanismName).newInstance();
		MechanismConfiguration mechanismConfiguration = mechanism.configDetail
		    (parentFrame,
		     (MechanismConfiguration)integrityConfiguration.get("integrity." + mechanismName + ".configuration"));
		System.out.println(mechanismConfiguration);
		integrityConfiguration.put("integrity." + mechanismName + ".configuration",mechanismConfiguration);
	    } catch(Exception e) {
		e.printStackTrace();
	    }//catch
     }//if
     else if(event.getSource() == helpButton) {
	    // Integrity
	    String str = (String)integrityPreferenceList.getList().getSelectedValue(); //rechte Liste
	    if(str == null)
		str = (String)integrityPreferenceList.getPreferenceList().getSelectedValue();//linke Liste
	        viewHelp("INTEGRITY",str);
	}//if
   }//method

   public static void viewHelp(String str1, String str2) {

	if (hp != null) {
	    hp.vanishWindow();
	}
	hp = new Help(System.getProperty("ssonet_help"));
	hp.viewPage (str1,str2);
    }


     public void changeLanguage(Locale language)
 {
	    intresource = ResourceBundle.getBundle("smi.baseConf.locale.Resources", language);
	    changeResource(intresource);
 }


   private void changeResource(ResourceBundle resource)
   {
    changeConfigurationButton.setText(resource.getString(changeConfigurationButtonTextKey));
    helpButton.setText(resource.getString("HELP"));
    integrityPanelLabel.setText(resource.getString("USE_AUTHENTICATION"));
    integrityPreferenceList.setHeader(resource.getString("PREFERENCELIST"),
	    resource.getString("AVAILABLE_MECHANISMS"));
   }

   public void writeConfig ()
   {
   // schreibt KonfigurationsDatei in Alf

   try{     String[] prefMechs;
            prefMechs = integrityPreferenceList.getPreferenceListItems();
            for (int i =0; i < prefMechs.length; i++){
            System.out.println("Preferences:"+prefMechs[i]);}
            integrityConfiguration.put("preflist.integrity",prefMechs);
	    //Konfiguration in Datei schreiben
	    FileOutputStream fos = new FileOutputStream(configDir+user+configFileName);
	    ObjectOutputStream oos = new ObjectOutputStream((OutputStream)fos);
            oos.writeObject(integrityConfiguration);
	    oos.close();
	    fos.close();
	}
	catch (Exception e){
	    System.out.println("Fehler: Konfigurationsdatei "
			       +"kann nicht geschrieben werden!");
	}//catch

   }

    public void changeUser(String user)
    {
    this.user = user;
    }


// Auslesen der Konfiguration der Integritt
 public void readConfig(){
	boolean configIsValid = true;
	try{
	    FileInputStream fis = new FileInputStream(configDir+user+configFileName);
	    ObjectInputStream ois = new ObjectInputStream(fis);
	    integrityConfiguration = (Hashtable)ois.readObject();

	    ois.close();
	    fis.close();
	}
	catch (Exception e){
	    System.out.println("Konfigurationsdatei Integritt "
			       +"nicht gefunden! Benutze Standardwerte.");
	    configIsValid = false;
	}
 }





// Methode getTokenized() aus StartUp fr auslesen der verfgbaren Mechanismen
      private String[] getTokenized (String s) {
	StringTokenizer st = new StringTokenizer(s);
	String[] ret = new String[st.countTokens()];
	int i = 0;
	while (st.hasMoreTokens()) {
	    ret[i++] = st.nextToken();
	}
	return ret;
    }


// Methode zum Aufbau des Frames
   private void initialize()
  {

        System.out.println("jbinit");
        GridBagLayout gridBagLayout = new GridBagLayout();
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
        System.out.println("jbinit1");

        this.setLayout(gridBagLayout);
        System.out.println("jbinit2");
        integrityPanelLabel = new JLabel();
        gridBagConstraints.anchor = GridBagConstraints.NORTH;
        gridBagConstraints.insets = new Insets(5,10,0,0);
        gridBagConstraints.fill = GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 0;
        gridBagConstraints.weighty = 0;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagLayout.setConstraints(integrityPanelLabel, gridBagConstraints);
        this.add(integrityPanelLabel);
        System.out.println("jbinit3");
        integrityPreferenceList = new JPreferenceList(12,
(String[])integrityConfiguration.get("preflist.integrity") ,
	    integrityMechanisms);
        System.out.println("jbinit3,2");
        gridBagConstraints.anchor = GridBagConstraints.SOUTH;
        gridBagConstraints.insets = new Insets(5,10,0,10);
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1;
        gridBagConstraints.weighty = 1;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;

        gridBagLayout.setConstraints(integrityPreferenceList, gridBagConstraints);
        System.out.println("jbinit3,5");
        this.add(integrityPreferenceList);
        System.out.println("jbinit4");
	JPanel buttonIntePanel = new JPanel();
        buttonIntePanel.setLayout(new BoxLayout(buttonIntePanel,BoxLayout.X_AXIS));
       // changeConfigurationButton[3] = new JButton();
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        gridBagConstraints.insets = new Insets(15,30,15,0);
        gridBagConstraints.fill = GridBagConstraints. NONE;
        gridBagConstraints.weightx = 0;
        gridBagConstraints.weighty = 0;
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagLayout.setConstraints(buttonIntePanel, gridBagConstraints);
        buttonIntePanel.add(changeConfigurationButton);
        changeConfigurationButton.addActionListener(this);
        changeConfigurationButton.setEnabled(false);
        changeConfigurationButton.setToolTipText("Click to configure the selected mechanism.");
        new PreferenceListSelectionListener(integrityPreferenceList.getPreferenceList(),
	    integrityPreferenceList.getList(),
	    changeConfigurationButton);
	buttonIntePanel.add(Box.createRigidArea(new Dimension(10,1)));
	helpButton.addActionListener(this);
	buttonIntePanel.add(helpButton);
        this.add(buttonIntePanel);
    //    tabbedPane.add(integrityPanel,getClass().getResource("images/green.gif"));
    //    this.add(tabbedPane);
    //      this.add(integrityPanel);
         // this.setBorder(new Border());
        intresource = ResourceBundle.getBundle("smi.baseConf.locale.Resources",Locale.GERMAN);
        changeResource(intresource);



   }

public void valueChanged(ListSelectionEvent event)
{
JList listWhereEventOccured = (JList)event.getSource();
}

 public static Hashtable getConfigurationIntegrity() {
	try {
	    return (Hashtable)(new ObjectInputStream(new FileInputStream
		(new File(System.getProperty("ssonet_cfg")+"users/"+System.getProperty("ssonet_userdir"),
		"IntegrityConfig.object")))).readObject();
	} catch(Exception e) {
	    return null;
	}
    }

    public static void main (String[] args)
   {
   try{
 //  AppletFrame testframe = new AppletFrame("TestFrame");
 //  BaseConfiguration base = new BaseConfiguration();
// Hashtable hash = new Hashtable();
// hash.put("preflist.integrity","TEST");
// ConfigurationIntegrity c =  new ConfigurationIntegrity(testframe,
           //             "C:/Jens/program/users/Alf/", new Hashtable());

   //c.create();
  // testframe.getContentPane().add(c);
  // ConfigurationIntegrity c = new ConfigurationIntegrity();
 //  c.setVisible(true);
  //  testframe.pack();
 //   testframe.show();
    }//try
          catch (Exception e){
          e.printStackTrace();
 //  System.out.println("Hier"+c.toString());
         }//catch
   }

}