/*
 * smi/baseConf/locale/Resources_en.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.baseConf.locale;

import java.util.ListResourceBundle;

public class Resources_en extends ListResourceBundle {
    public Object[][] getContents() {
	return contents;
    }

    static final Object[][] contents = {
	// Buttons...
	{"YES","Yes"},
	{"NO","No"},
	{"OK","Ok"},
	{"CANCEL","Cancel"},
	{"ABORT","Abort"},
	{"RETRY","Retry"},
	{"DETAIL","Change Configuration."},
	{"WARNING","Warning"},
	{"MESSAGE","Message"},
	{"QUESTION","Question"},

	// Menu.....
	{"BASE CONFIGURATION","Base Bonfiguration"},
	{"SETTINGS","Options"},
	{"SAVE SETTINGS FOR USER", "Save settings for user"},
	{"USER","User"},
	{"NAME", "Name"},
	{"SELECT/CREATE USER","Select/Create User"},
	{"INFO","About"},
	{"KEYS","Keys"},
	{"LANGUAGE","Language"},
	{"HELP","Help"},
	{"GERMAN","German"},
	{"ENGLISH","English"},
	{"PERFORMANCE_TEST","Performance Test"},
	{"RATING","Rating"},
	{"PROVIDER","Provider"},
	{"ASYMMETRIC_MECHANISMS","Asymmetric Mechanisms"},
	{"DSA","DSA"},
	{"ELGAMAL","ElGamal"},
	{"RSA","RSA"},
	{"NEW_DSA_KEY","DSA"},
	{"NEW_RSA_KEY","RSA"},
	{"NEW_ELGAMAL_KEY","ElGamal"},
	{"NEW_DSA_CERTIFICATE","DSA Key"},
	{"NEW_RSA_CERTIFICATE","RSA Key"},
	{"NEW_ELGAMAL_CERTIFICATE","ElGamal Key"},
	{"NEW_MECHANISM_KEY","New Key for"},
	{"NEW_MECHANISM_CERTIFICATE","New Certificate for"},

	// Tab Header....
	{"CONFIDENTIALITY","Confidentiality"},
	{"ANONYMITY", "Anonymity"},
	{"INTEGRITY","Integrity"},
	{"ACCOUNTABILITY","Accountability"},

	// Titles
	{"CHIPHER_MESSAGES","Message Encryption"},
	{"PREFERENCELIST","Preference List"},
	{"AVAILABLE_MECHANISMS","Available Mechanisms"},
	{"CHOSEN_ROUTE","Chosen Route"},
	{"AVAILABLE_MIXES","Available Mixes"},
	{"USEAGE_OF_MIXES","Use a Chain of MIXes"},
	{"USE_AUTHENTICATION","Use Symmetric Authentication Mechanisms"},
	{"CREATE_SIGNATURES","Create Digital Signatures"},
	{"ACCEPT_SIGNATURES","Accept Digital Signatures"},
	{"CATEGORIE","Categorie"},
	{"ASK_BEFORE_SIGN","Ask Before Creating a Digital Signature"},

	// Detail configuration
	{"DETAIL CONFIGURATION","Detail Configuration"},
	{"MODE","Mode"},
	{"KEY","Key"},
	{"ROUNDS","Rounds"},
	{"PREFERENCE LIST","Preference List"},
	{"AVAILABLE MODES","Available modes"},
	{"AVAILABLE VARIANTS","Available variants"},
	{"MINIMAL KEY LENGTH","Minimal key length (bit):"},
	{"NUMBER OF MINIMUM ROUNDS","Number of minimum rounds:"},
	{"VARIANTS","Variants"},
	{"CERTIFICATE","Certificate"},
	{"THIS CERTIFICATE IS VALID TO","This certificate is valid to:"},
	{"REFRESH CERTIFICATE","Refresh certificate"},
	{"REFRESH KEY","Refresh key"},
	{"NO CERTIFICATE PRESENT","     No certificate present!     "},
	{"PLEASE CREATE A CERTIFICATE","Please create a certificate!"},

	//Certificate
	{"CERTIFICATE OPTIONS","Certificate options"},
	{"VALIDITY RANGE IN DAYS","Validity range in days"},
	{"INVALID KEY MESSAGE","Some certificates are not valid."},
	{"VALID KEY MESSAGE","All keys and certifications are valid."},
	{"CREATE KEY MESSAGE","Key Generation successful. \nKeys are placed in files:"},
	{"CREATE CERTIFICATES MESSAGE","Certification successful. \nCertificates are placed in files:"},
	{"CREATE CERTIFICATES FAILED","Error while creating certificates.\nCertificates are not created."},
	{"NO KEY PAIR","No key pair found. Please rerun key pair generation."},
	{"CERTIFICATE NOT FOUND", "A certificate was not found. \nPlease create new certificates."},
	{"KEY CREATION FAILED", "Key creation failed."},

	//Rating
	{"RATING","Rating"},
	{"SECURITY OF THE ALGORITHM","Security of the algorithm: Weight "},
	{"RATINGTOOLTIP1","This determines the importance of the security of the algorithm."},
	{"SECURITY OF THE IMPLEMENTATION","Security of the implementation: Weight "},
	{"RATINGTOOLTIP2","This determines the importance of the security of the implementation."},
	{"PERFORMANCE","Performance: Weight "},
	{"RATINGTOOLTIP3","This determines the importance of performance."},
	{"MINIMUM ALGORITHM THROUGHPUT","Minimum algorithm throughput: "},
	{"RATINGTOOLTIP4","This determines the minimum throughput of the algorithm."},
	{"LOW COSTS","Low Costs: Weight "},
	{"RATINGTOOLTIP5","This determines the importance of low costs."},
	{"MAXIMUM COSTS","Maximum costs: Weight "},
	{"RATINGTOOLTIP6","This determines the maximum costs of an algorithm."},
	{"CHALLANGES","Challenges: Weight "},
	{"RATINGTOOLTIP7","This determines the importance of processed challenges."},
	{"PERFORMANCETEST","Performancetest"},
	{"RATINGTOOLTIP8","Determine Speed of installed algorithms"},
	{"RATINGTOOLTIP9","Rating values for confidentiality"},
	{"RATINGTOOLTIP10","Rating values for integrity"},
	{"RATINGTOOLTIP11","Rating values for accountability"},
	{"RATINGTOOLTIP12","Rating values for anonymity"},
	{"TOO SLOW"," (too slow)"},
	{"TOO EXPENSIVE"," (too expensive)"},
	{"TOO SLOW&EXPENSIVE"," (too slow & too expensive)"},
	{"FILES MISSING","Sorry, there are some files missing.\nPlease rerun Performance test."},

	//User Dialog
	{"SELECT USER", "Select User"},
	{"USERS", "Users"},
	{"CREATE USER", "Create User"},
	{"USER PROPERTIES", "User Properties"},
	{"USER ID", "UserID"},
	{"DIRECTORY", "Directory"},
	{"COMMIT CHANGES", "Commit Changes"},
	{"N/A", "N/A"},
	{"ERROR", "Error"},
	{"CREATE KEYS AND CERTIFICATES", "Create Keys and Certificates"},
	{"CERTIFICATES", "Certificates"},
	{"CREATE CERTIFICATES", "Create Certificates"},
	{"TEST CERTIFICATES", "Teste Zertifikate"},
	{"APPLY", "Apply"},
	{"USER DATA", "User Data"},
	{"USER DIRECTORY", "User directory"},
	{"DOES NOT EXIST", "does not exist"},
	{"IS NOT A DIRECTORY", "is not a directory"},
	{"IS UNREADABLE", "is unreadable"},
	{"ERROR READING USERS", "Error reading users"},
	{"TESTKEY CERTIFICATE", "Testkey certificate"},
	{"CIPHERKEY CERTIFICATE", "Cipherkey certificate"},

    };
}
