
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package smi.mechanisms;

import smi.mechanisms.Mechanism;
import smi.baseConf.BaseConfiguration;
import smi.mechanisms.ParameterNotCompatibleException;
import ssonet.SSONETConstants;
import smi.io.IOStream;
import gateway.GatewayWindow;
import ssonet.KeyExchange;
import java.util.Hashtable;
import smi.baseConf.ConfigurationAccountability;
import smi.baseConf.ConfigurationConfidentiality;
import smi.baseConf.ConfigurationIntegrity;

public class MechanismInstance {

public static Hashtable config;

  public MechanismInstance() {
  }

  /** creates a mechanism without key exchange, e.g. for performance tests or similar
     * wird verwendet in ssonet.SSonetStream
    */
    public static IOStream getMechanismInstance(int mechanismType,
	String mechanismName,
	IOStream ioStream) throws ParameterNotCompatibleException
    {
	try {
	    String packageName = null;
	    if(mechanismType == SSONETConstants.CONFIDENTIALITY)
		packageName = "confidentiality.";
	    else if(mechanismType == SSONETConstants.ACCOUNTABILITY_SIGN||
		mechanismType == SSONETConstants.ACCOUNTABILITY_ACCEPT)
		packageName = "accountability.";
	    else if(mechanismType == SSONETConstants.INTEGRITY)
		packageName = "integrity.";
	    else {
		throw new ParameterNotCompatibleException();
	    }
	    Mechanism mechanism = (Mechanism)Class.forName("smi.mechanisms." + packageName + mechanismName).newInstance();
     //nderung
	    mechanism.init(ioStream, getMechanismConfiguration(mechanismType, mechanismName));
	    return mechanism;
	} catch(Exception e) {
	    e.printStackTrace();
            System.out.println("getMechanismsInstance1");
	    throw new ParameterNotCompatibleException();
	}
    }

       public static IOStream getMechanismInstance(int mechanismType,
	String mechanismName,
	IOStream ioStream,
	MechanismConfiguration partnerMechanismConfiguration,
	KeyExchange keyExchange) throws ParameterNotCompatibleException
    {
	try {
 //////////////////////////////////////////////////////////////////////////////
 System.out.println("Hier wird getMechanismsInstance2 aufgerufen!!!");
	    String packageName = null;
	    if(mechanismType == SSONETConstants.CONFIDENTIALITY)
		packageName = "confidentiality.";
	    else if((mechanismType == SSONETConstants.ACCOUNTABILITY_SIGN) ||
		(mechanismType == SSONETConstants.ACCOUNTABILITY_ACCEPT))
		packageName = "accountability.";
	    else if(mechanismType == SSONETConstants.INTEGRITY)
		packageName = "integrity.";
	    else throw new ParameterNotCompatibleException();
	    System.out.println("*"+"smi.mechanisms." + packageName + mechanismName);
	    MechanismConfiguration mechanismconfiguration=null;
     //nderung
	    mechanismconfiguration = (MechanismConfiguration)getMechanismConfiguration(mechanismType, mechanismName);
	    String gatewayName = ((String[])mechanismconfiguration.get("Providerlist"))[0];
	    System.out.println("BaseConfig: mechanismconfiguration erhalten.");
	    System.out.println("Provider: "+gatewayName);
	    if(gatewayName.equals("Cryptix"))
	    {
		Mechanism mechanism = (Mechanism)Class.forName("smi.mechanisms." + packageName + mechanismName).newInstance();
		System.out.println("**");
		mechanism.init(ioStream,
  //nderung
		    getMechanismConfiguration(mechanismType, mechanismName),
		    partnerMechanismConfiguration,
		    keyExchange);
		System.out.println("***");
		return mechanism;
	    } else {
		//? hier eine Art Gatewaymechanismus instanziieren.
		//dieser hat die Aufgabe, 1. die Aushandlung zu vollziehen und dann
		//den iostream vom Partner zum Gateway umzuleiten und diesen dann
		//im brauchbaren Format (Rckmechanismus) zu empfangen und auszugeben.
		System.out.println("init Gateway.");
		Hashtable configuration = GatewayWindow.readGatewayConfiguration();
		MechanismConfiguration gwHashConfig = new MechanismConfiguration();
		MechanismConfiguration mechs = new MechanismConfiguration();
		String[] gwConfig = (String[])configuration.get(gatewayName);
		//System.out.println("gwconfig: 1. put: gatewayName=" + gatewayName); --> nderung
		mechs.put("BACK", getMechanismConfiguration(mechanismType, gwConfig[GatewayWindow.GW_BACK_MECH]));
		//System.out.println("gwconfig: 2. put: BackMech="+ gwConfig[GatewayWindow.GW_BACK_MECH]);
                //nderung
		mechs.put("HIN", getMechanismConfiguration(mechanismType, gwConfig[GatewayWindow.GW_HIN_MECH]));
		//System.out.println("gwconfig: 3. put: HinMech="+ gwConfig[GatewayWindow.GW_HIN_MECH]);
		//System.out.println("Hinmech-Variante = " + ((String[])getMechanismConfiguration(mechanismType, gwConfig[GatewayWindow.GW_HIN_MECH]).get("KeyVariante"))[0] );
		gwHashConfig.put("GATEWAY", gwConfig);
		//System.out.println("gwconfig: 4. put");
		gwHashConfig.put("PACKAGENAME", packageName);
		//Mechanism gw = (Mechanism)Class.forName("smi.mechanisms." + packageName + "Gateway").newInstance();
		Mechanism gw;
		if (packageName.equals("confidentiality.")) {
		    gw = (Mechanism)Class.forName("smi.mechanisms.confidentiality.Gateway").newInstance();
		}
		else if (packageName.equals("accountability.")) {
		    System.out.println("accountability Gateway erzeugen");
		    gw = (Mechanism)Class.forName("smi.mechanisms.accountability.Gateway").newInstance();
		    System.out.println("accountability Gateway generiert");
		} else {
		    gw = (Mechanism)Class.forName("smi.mechanisms.Gateway").newInstance();
		}
		System.out.println("GW.init aufrufen");
		gw.init(ioStream,
		    mechs,
		    gwHashConfig,
		    keyExchange);
		System.out.println("Bis hierhin erfolgreich!");
		return gw;
	    }
	} catch (ParameterNotCompatibleException e) {
	    throw e;
	} catch (Exception e) {
	    System.out.println("Could not instantiate mechanisms");
	    e.printStackTrace();
	    return null;
	}
    }

 public static MechanismConfiguration getMechanismConfiguration (int mechanismType, String mechanismName) {

	MechanismConfiguration mechanismConfiguration = null;
	if(mechanismType == SSONETConstants.CONFIDENTIALITY){
            help(1);
	    mechanismConfiguration = (MechanismConfiguration)config.get(mechanismName + ".configuration");
            }
	else if(mechanismType == SSONETConstants.INTEGRITY){
            help(2);
	    mechanismConfiguration = (MechanismConfiguration)config.get
	    ("integrity." + mechanismName + ".configuration");
              }
	else if(mechanismType == SSONETConstants.ACCOUNTABILITY_SIGN){
            help(3);
	    mechanismConfiguration = (MechanismConfiguration)config.get
	    ("signatures.sign." + mechanismName + ".configuration");
           }
	else if(mechanismType == SSONETConstants.ACCOUNTABILITY_ACCEPT){
            help(3);
	    mechanismConfiguration = (MechanismConfiguration)config.get
	    ("signatures.accept." + mechanismName + ".configuration");
              }
	else return null;
	if(mechanismConfiguration != null)
	    return mechanismConfiguration;
	String packageName = null;
	if(mechanismType == SSONETConstants.CONFIDENTIALITY)
	    packageName = "confidentiality.";
	else if((mechanismType == SSONETConstants.ACCOUNTABILITY_SIGN) ||
	    (mechanismType == SSONETConstants.ACCOUNTABILITY_ACCEPT))
	    packageName = "accountability.";
	else if(mechanismType == SSONETConstants.INTEGRITY)
	    packageName = "integrity.";
	else return null;
	try {
	    Mechanism mechanism = (Mechanism)Class.forName("smi.mechanisms." + packageName + mechanismName).newInstance();
	    return mechanism.getDefaultConfiguration();
	} catch(Exception e) {
	    e.printStackTrace();
	    return null;
	}
    }
// Read the actual configuration out of the Panels
    public static void help(int which)
    {

    try{
    switch(which){
         case 1:
         config = ConfigurationConfidentiality.getConfigurationConfidentiality();
         break;
         case 2:
         config = ConfigurationIntegrity.getConfigurationIntegrity();
         break;
         case 3:
         config = ConfigurationAccountability.getConfigurationAccountability();
         break;
                 }//switch

    }catch(Exception e)
    {
    e.printStackTrace();
    }
    }

}