/*
 * smi/mechanisms/SignatureObject.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.mechanisms;

import java.io.Serializable;

import java.io.ByteArrayOutputStream;
import java.io.ObjectOutputStream;

public class SignatureObject implements Serializable {
    private Object object;
    private byte[] signature;

    public SignatureObject(Object object) {
	this.object = object;
    }

    public SignatureObject(Object object, byte[] signature) {
	this.object = object;
	this.signature = signature;
    }

    public Object getObject() {
	return object;
    }

    public byte[] getObjectAsByteArray() {
	try {
	    ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
	    ObjectOutputStream objectOutputStream = new ObjectOutputStream(byteArrayOutputStream);
	    objectOutputStream.writeObject(object);
	    objectOutputStream.flush();
	    return byteArrayOutputStream.toByteArray();
	} catch (Exception e) {
	    System.out.println("Error while transforming into ByteArray.");
	    e.printStackTrace();
	    return null;
	}
    }

    public byte[] getSignature() {
	return signature;
    }

    public void setSignature(byte[] signature) {
	this.signature = signature;
    }

}
