/*
 * smi/mechanisms/confidentiality/Blowfish.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.mechanisms.confidentiality;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JLabel;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;

import smi.mechanisms.AbstractConfidentialityMechanism;
import smi.mechanisms.MechanismConfiguration;
import smi.mechanisms.DetailConfigurationDialog;
import smi.baseConf.BaseConfiguration;

import ssonet.SSONETConstants;

public class Blowfish extends AbstractConfidentialityMechanism {

    private String ROUNDSTOOLTIP = "minimal: 1 - maximal: 16 - save: 16";
    public Blowfish() {}

    public MechanismConfiguration getDefaultConfiguration()
    {
        MechanismConfiguration  defaultConfiguration = new MechanismConfiguration();
        String defaultMode[] = {"OFB"};
        String defaultProvider[] = {"Cryptix"};
        defaultConfiguration.put(PROVIDERLIST, defaultProvider);
        defaultConfiguration.put(KEY_MODE_PREFERENCELIST, defaultMode);
        defaultConfiguration.put(KEY_KEYLENGTH, new Integer(80));
        defaultConfiguration.put(KEY_ROUNDS, new Integer(16));
        return defaultConfiguration;
    }

    public MechanismConfiguration configDetail(JFrame parentFrame, MechanismConfiguration actualConfiguration)
    {
        if(actualConfiguration == null) actualConfiguration = getDefaultConfiguration();

        DetailConfigurationDialog detailConfigurationDialog = new DetailConfigurationDialog(parentFrame, getClass().getName());

        // provider
        detailConfigurationDialog.addTabProvider((String[])actualConfiguration.get(PROVIDERLIST));

        // modes
        detailConfigurationDialog.addTabMode((String[])actualConfiguration.get(KEY_MODE_PREFERENCELIST),
	    SSONETConstants.CONFIDENTIALITY);

        // key length
        Integer actualKeyLength = (Integer)actualConfiguration.get(KEY_KEYLENGTH);
        if (actualKeyLength == null)
            actualKeyLength = new Integer(80);
        detailConfigurationDialog.addTabKey(1,448,1, actualKeyLength.intValue());

        // rounds
        Integer actualRounds = (Integer)actualConfiguration.get(KEY_ROUNDS);
        if (actualRounds == null) actualRounds = new Integer(16);
        detailConfigurationDialog.addTab(BaseConfiguration.getLangResources().getString("ROUNDS"),
	    detailConfigurationDialog.roundsPanel(actualRounds.intValue(), ROUNDSTOOLTIP));
        detailConfigurationDialog.pack();
        detailConfigurationDialog.setResizable(false);
        detailConfigurationDialog.setLocationRelativeTo(parentFrame);
        detailConfigurationDialog.setVisible(true);
        if(detailConfigurationDialog.getReturnCode()) {
            actualConfiguration.put(PROVIDERLIST, detailConfigurationDialog.getProviderPreferenceList());
            actualConfiguration.put(KEY_MODE_PREFERENCELIST, detailConfigurationDialog.getModePreferenceList());
            actualConfiguration.put(KEY_KEYLENGTH, new Integer(detailConfigurationDialog.getKeyLength()));
            actualConfiguration.put(KEY_ROUNDS, new Integer(detailConfigurationDialog.getRounds()));
        }
        System.out.println(actualConfiguration);
        return actualConfiguration;
    }
}
