/*
 * experimental source code
 * sproxy/client/ClientAdapter.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package sproxy.client;
import  java.net.*;
import  ssonet.*;
import sproxy.awt.ClientConfigDialog;

/**
* Dies ist die Hauptklasse, die den Client startet.
*/
public class ClientAdapter extends Thread {

    public static void main(String args[]) {

	AbstractClient cw=new UniClient(0,0,"test","test",0); // Initialisierung aus technischen Gruenden

	// Grafische Konfiguration erwuenscht
	ClientConfigDialog dlg = new ClientConfigDialog();
	if (dlg.status == false) System.exit(0); // Dialog wurde mit Abbruch beendet
	new ClientAdapter(dlg.getConfig());
    }

    protected ServerSocket server_listening_socket;
    protected AbstractClient cw;

    public ClientAdapter(AbstractClient cw) {
	this.cw = cw;
	// zuerst auf dem lokalen Rechner lauschen, erst wenn da eine Verbindung besteht, den SSONETServer anbinden
	System.out.println("Beginne Aufbau Server localhost");
	try {
	    server_listening_socket = new ServerSocket(cw.getlisteningPort(),5);
	} catch (Exception e) {
	    System.out.println("Fehler im Aufbau des lokalen ServerSockets: "+e);
	    System.exit(0);
	}
	System.out.println("Lokaler Server laeuft und wartet auf Verbindungen auf Port "+cw.getlisteningPort());
	this.start();
    }

    public void run() {
	Socket client_socket;
	try {
	    while (true) {
		client_socket = server_listening_socket.accept();
		System.out.println("Verbindung zu "+client_socket.getInetAddress());
		System.out.println("Baue SSONETConnection");
		new ClientAdapterConnection(cw, client_socket);
		System.out.println("o.k., warte auf weitere Verbindungen");
	    }
	} catch (Exception e) {
	    System.out.println("Fehler im ClientAdapter: "+e);
	    System.exit(0);
	}
    }
}
