/*
 * experimental source code
 * sproxy/client/ClientAdapterConnection.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package sproxy.client;
import java.net.*;
import java.io.*;
import java.util.Vector;

import ssonet.*;
import smi.appConf.ApplicationConfiguration;
import smi.appConf.ActionConfiguration;
import smi.io.IOStream;
import sproxy.SProxyMonitor;

import javax.swing.JFrame;

/**
* Verbindung einerseits zum lokalen Rechner, andererseits zum SSONETServer
*/
public class ClientAdapterConnection extends Thread {

    protected AbstractClient cw;                // Informationen, die fuer die Verbindung gebraucht werden
    protected Socket client_socket;             // Der Socket zum lokalen Rechner
    protected BufferedInputStream from_client;  // alles, was vom lokalen Rechner kommt
    protected BufferedOutputStream to_client;   // alles, was zum lokalen Rechner hingehen soll
    protected IOStream ios;                 // zur Kommunikation mit der SSONETLeitung
    protected SSONETClientConnection sw;        // Verschluesselte Leitung

    public ClientAdapterConnection(AbstractClient cw, Socket client_socket) {
	this.cw            = cw;
	this.client_socket = client_socket;

	// System.out.println("*jetzt ist die ClientAdapterConnection am Zug");
	// zuerst holen wir uns die Streams vom lokalen Rechner
	try {
	    // Ein- und Ausgabestrom vom lokalen Rechner besorgen
	    from_client = new BufferedInputStream(client_socket.getInputStream());
	    to_client   = new BufferedOutputStream(client_socket.getOutputStream());

	    // SSONETSocket zum SSONETServer bilden
	    System.out.println("configure Action.");
	    if (smi.appConf.ApplicationConfiguration.getActionConfiguration(cw.getAppName(), cw.getID())==null) {
		System.out.println("No Actionconfiguration found.");
		SSONETConstraints configuration = new SSONETConstraints ();
		ApplicationConfiguration.configureAction(null, cw.getAppName(),
		    "Hello Proxy", (short)cw.getID(), configuration);
	    }
	    try {
		sw = new SSONETClientConnection(cw.getAppName(), cw.getID(), new JFrame(), cw.getSSONETServer(), cw.getSSONETPort());
	    } catch (IOException w) {
		System.out.println("Verbindungsaufbau nicht moeglich: Konfiguration nicht gefunden !\nSchliesse Verbindungen. ");
		try {
		    from_client.close();
		    to_client.close();
		    ios.close();
		    sw.close();
		    return;
		} catch (Exception wa) {};
		return ;
	    }

	    // entsprechend Ein- und Ausgabestrom vom SSONETServer besorgen
	    ios = sw.connect();

	    // ok, jetzt fertig
	} catch (Exception e) {
	    System.out.println("Verbindung konnte nicht geschaltet werden ! Evtl. fehlt dem Server die Konfiguration fuer die Anwendung ! ");
	    System.exit(0);
	} // of catch
	this.start();
    } // of ClientAdapterConnection()

    public  void run() {
	char ch;
	SProxyMonitor sli = new SProxyMonitor(ios); // lauscher

	sli.start();

	while (true) {
	    try {

		// von lokal zu SSONET
		if (from_client.available()>0) {
		    ch = (char)from_client.read();
		    ios.writeObject(new Character(ch));
		}

		// von SSONET zu lokal
		if (sli.vec.size()>0) {
		    ch = ((Character)sli.vec.elementAt(0)).charValue();
		    sli.vec.removeElementAt(0);
		    to_client.write(ch);  // wegschicken
		    to_client.flush();
		}
	    } catch (Exception f) {
		System.out.println("Fehler beim Aufbau der Verbindung: "+f);
		try {
		    from_client.close();
		    to_client.close();
		    ios.close();
		} catch (Exception qz) {};
	    }
	}
    }
}
