/*
 * experimental source code
 * sproxy/server/ServerProxyConnection.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package sproxy.server;
import  sproxy.SProxyMonitor;

import  java.net.*;
import  java.io.*;
import  java.util.Vector;

import  smi.io.IOStream;
import  ssonet.*;

/**
* stellt die Verbindung dar
*/
public class ServerProxyConnection extends Thread {

    protected int sendport;        // Der Port des lokalen Dienstes
    protected IOStream qw;     // Die SSONETConnection
    protected Socket localservice; // lokaler Dienst

    protected BufferedInputStream from_localservice;   // Kommunikationselemente zum lokalen Dienst
    protected BufferedOutputStream to_localservice;

    public ServerProxyConnection(IOStream qw, int sendport, AbstractServer df) {
	System.out.println("*ServerProxyConnection wurde gestartet");
	System.out.println("*Zuerst Verbindung zum lokalen Dienst aufnehmen");

	this.sendport = sendport;
	this.qw = qw;

	try {
	    // Aufbau der Verbindung zum lokalen Dienst, inkl. holen der Input/Output Streams
	    localservice      = new Socket(df.getRR(), sendport);
	    from_localservice = new BufferedInputStream(localservice.getInputStream());
	    to_localservice   = new BufferedOutputStream(localservice.getOutputStream());
	    System.out.println("*Verbindung zum Dienst auf "+df.getRR()+" erfolgreich aufgenommen !");
	} catch (Exception e) {
	    System.out.println("Fehler in Verbindungsaufbau zu "+df.getRR()+": "+e);
	    System.exit(0);
	}
	System.out.println("*Starte Kommunikationsthread");
	this.start();
    }

    public void run() {
	char ch;
	Character tq;
	SProxyMonitor sli = new SProxyMonitor(qw);

	sli.start();

	while (true) {
	    try {
		// liegt etwas vor vom lokalen Dienst ?
		if (from_localservice.available()>0) {
		    ch = (char)from_localservice.read();             // auslesen des Zeichens
		    qw.writeObject(new Character(ch));               // Verpacken als Character und schicken wir es ueber die SSONET
		}

		if (sli.vec.size()>0) {
		    ch = ((Character)sli.vec.elementAt(0)).charValue();
		    sli.vec.removeElementAt(0);

		    to_localservice.write(ch);                        // schicken wir das Zeichen zum lokalen Dienst
		    to_localservice.flush();                          // und zwar sofort
		}
	    } catch (Exception e) {
		System.out.println("**Error in ServerProxyConnection: "+e);
	    }
	}
    }
}
