/*
 * ssonet/SSONETStream.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package ssonet;

import smi.mechanisms.MechanismInstance;
import smi.io.IOStream;

public class SSONETStream implements IOStream {
    IOStream ioStream;
    private int id;

    public SSONETStream (ConnectionConfiguration config, IOStream stream) throws Exception {
	id = config.id;
	ioStream = stream;
	if(config.strConfidentiality != null)
	    try {
	    ioStream = MechanismInstance.getMechanismInstance(SSONETConstants.CONFIDENTIALITY,
		config.strConfidentiality,
		ioStream);
	} catch(Exception e) {
	    throw e;
	}
	if(config.strAccountability != null)
	    try {
	    ioStream = MechanismInstance.getMechanismInstance(SSONETConstants.ACCOUNTABILITY_SIGN,
		config.strAccountability,
		ioStream);
	} catch(Exception e) {
	    throw e;
	}
	if(config.strIntegrity != null)
	    try {
	    ioStream = MechanismInstance.getMechanismInstance(SSONETConstants.INTEGRITY,
		config.strIntegrity,
		ioStream);
	} catch(Exception e) {
	    throw e;
	}
    }

    public SSONETStream (int id, IOStream stream) {
	this.id = id;
	this.ioStream = stream;
    }

    public int available() {
	return ioStream.available();
    }

    public void close() {
	ioStream.close();
    }

    public int getID() {
	return id;
    }

    public Object readObject ()throws Exception {
	try {
	    return ioStream.readObject();
	} catch(Exception e) {
	    throw e;
	}
    }

    public void writeObject (Object o)throws Exception {
	try {
	    ioStream.writeObject(o);
	} catch(Exception e) {
	    throw e;
	}
    }
}
