/*
 * state/TreeData.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package state;

import java.awt.Color;
import java.awt.Font;
import java.awt.Toolkit;
import javax.swing.ImageIcon;
import state.StateTreeConstants;
public class TreeData extends Object {
    protected byte importance;
    protected Color color;
    protected String string;
    protected ImageIcon icon;
    public TreeData(int newIconKind, byte newImportance, Color newColor, String newString) {
	importance = newImportance;
	color = newColor;
	string = newString;
	setIcon(newIconKind);
    }
    public Color getColor() {
	return color;
    }
    public ImageIcon getIcon() {
	return icon;
    }
    public byte getImportance() {
	return importance;
    }
    public void setColor(Color newColor) {
	color = newColor;
    }
    public void setIcon(int iconKind) {
	try {
	    switch (iconKind) {
	    case StateTreeConstants.CONFLICTICON :
		icon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(
		    getClass().getResource("images/conflict.gif")));
		break;
	    case StateTreeConstants.ATTENTIONICON :
		icon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(
		    getClass().getResource("images/attention.gif")));
		break;
	    case StateTreeConstants.INFOICON :
		icon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(
		    getClass().getResource("images/info.gif")));
		break;
	    case StateTreeConstants.GRAYICON :
		icon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(
		    getClass().getResource("images/gray.gif")));
		break;
	    case StateTreeConstants.DEBUGICON :
		icon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(
		    getClass().getResource("images/debug.gif")));
		break;
	    default :
		icon = null;
		break;
	    }
	} catch (Exception e) {
	    System.out.println("Couldn't load images: " + e);
	}
    }
    public void setImportance(byte newImportance) {
	importance = newImportance;
    }
    public void setString(String newString) {
	string = newString;
    }
    public String string() {
	return string;
    }
    public String toString() {
	return string;
    }
}
