/*
 * Generator/myKeyPairGenerator.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package trustcenter;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.security.KeyPair;
import java.security.KeyPairGenerator;

public class myKeyPairGenerator {
    public myKeyPairGenerator(String keyPairName, String algorithmName) {
	try {
	    KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance(algorithmName);
	    System.out.println("initialize KeyPairGenerator.");
	    keyPairGenerator.initialize(1024);
	    System.out.println("generate KeyPair.");
	    KeyPair ownKeyPair = keyPairGenerator.generateKeyPair();

	    System.out.println("public key:\n"+ownKeyPair.getPublic().toString());
	    System.out.println("\nprivate key:\n"+ownKeyPair.getPrivate().toString());

	    FileOutputStream fileOutputStream = new FileOutputStream(keyPairName+algorithmName+"publicKey.der");
	    System.out.println("writing public key to File: "+keyPairName+algorithmName+"publicKey.der");
	    fileOutputStream.write(ownKeyPair.getPublic().getEncoded());
	    fileOutputStream.close();

	    fileOutputStream = new FileOutputStream(keyPairName+algorithmName+"publicKey.object");
	    System.out.println("writing private key to File: "+keyPairName+algorithmName+"publicKey.object");
	    ObjectOutputStream objectOutputStream = new ObjectOutputStream(fileOutputStream);
	    objectOutputStream.writeObject(ownKeyPair.getPublic());
	    fileOutputStream.close();
	    objectOutputStream.close();

	    fileOutputStream = new FileOutputStream(keyPairName+algorithmName+"privateKey.der");
	    System.out.println("writing private key to File: "+keyPairName+algorithmName+"privateKey.der");
	    fileOutputStream.write(ownKeyPair.getPrivate().getEncoded());
	    fileOutputStream.close();

	    fileOutputStream = new FileOutputStream(keyPairName+algorithmName+"privateKey.object");
	    System.out.println("writing private key to File: "+keyPairName+algorithmName+"privateKey.object");
	    objectOutputStream = new ObjectOutputStream(fileOutputStream);
	    objectOutputStream.writeObject(ownKeyPair.getPrivate());
	    fileOutputStream.close();
	    objectOutputStream.close();
	}
	catch(java.lang.Exception ex) {
	    System.out.println(ex);
	}
    }

    public static void main(String[] argv){
	if(argv.length <= 1){
	    System.out.println("Usage: myKeyPairGenerator <Keypair-name> <Algorithm-name>\n");
	    System.exit(0);
	}
	new myKeyPairGenerator(argv[0], argv[1]);
    }
}
